<?php
/* 
Navigator of WWLabor 
https://www.mwiede.de/windows-php-webserver/wwlabor/
*/

require_once ("main.inc.php");
require_once ($CONFIG_GLOBAL["wwadmin_path"]."/class.wwadminsesison.inc.php");
$session = new WWAdminSession ();
if (!$session->isLogin ()) {
	die ("Login with http://".$_SERVER["HTTP_HOST"]."/wwadmin/");
}

$cmd = WSystem::getParam ("cmd");
$html = "";
$errText = "";
$fCommand = false;

function createFormRename ($oldFilename, $newFilename="") {
	global $errText;
	$htmlForm = '
	<div class="toolbar"><span>Rename '.htmlspecialchars ($oldFilename).'</span><button onclick="window.location.href=\''.WSystem::rebuildURI ($_SERVER["PHP_SELF"], array ("f"=>rtrim($oldFilename,"/")), false, array ("cmd")).'\';return false;">Abort</button></div>
	<form method="post" action="'.WSystem::rebuildURI ($_SERVER["PHP_SELF"], array (), false, array ("cmd")).'">
		<input type="hidden" name="cmd" value="rename" />			
		<input type="hidden" name="f" value="'.htmlspecialchars ($oldFilename).'" />
		'.(!empty ($errText) ? '<p class="error msgText">'.htmlspecialchars ($errText).'</p>': '').'
		<div class="box">
			<div class="input_item">
				<div class="input_description">Filename</div>
				<div class="input_value"><div class="input_wrap"><input id="focus_id"  class="inputfield" value="'.htmlspecialchars ($newFilename).'" type="text" name="new_filename" /></div></div>
			</div>
			<div class="input_item">
				<input class="button edit_button" name="submit" type="submit" value="Rename" />
			</div>
		</div>
	</form>
	';
	return $htmlForm;
}


function createFormNew ($oldFilename, $newFilename="") {
	global $errText;
	if (is_dir ($oldFilename))
		$pi["dirname"] = $oldFilename;
	else
		$pi = pathinfo ($oldFilename);
	
	$htmlForm = '
	<div class="toolbar"><span>Create file in '.htmlspecialchars (rtrim($pi["dirname"], "/")).'</span><button onclick="window.location.href=\''.WSystem::rebuildURI ($_SERVER["PHP_SELF"], array ("f"=>rtrim($oldFilename,"/")), false, array ("cmd")).'\';return false;">Abort</button></div>
	<form method="post" action="'.WSystem::rebuildURI ($_SERVER["PHP_SELF"], array (), false, array ("cmd")).'">
		<input type="hidden" name="cmd" value="new" />			
		<input type="hidden" name="f" value="'.htmlspecialchars ($oldFilename).'" />
		'.(!empty ($errText) ? '<p class="error msgText">'.htmlspecialchars ($errText).'</p>': '').'
		<div class="box">
			<div class="input_item">
				<div class="input_description">Filename</div>
				<div class="input_value"><div class="input_wrap"><input id="focus_id" class="inputfield" value="'.htmlspecialchars ($newFilename).'" type="text" name="new_filename" /></div></div>
			</div>
			<div class="input_item">
				<input class="button edit_button" name="submit" type="submit" value="Create file" />
			</div>
		</div>
	</form>
	';
	return $htmlForm;
}

// Commands
switch ($cmd) {

	case "new":
		$newFilename = createSecurePath (trim (WSystem::getParam ("new_filename")));
		if (WSystem::isParam ("new_filename")) {
		
			
			if (empty ($newFilename)) {
				$errText = "Please insert a new filename.";
			}
			else
			if (!WFormat::check  ($newFilename, "filename", $errText)) {
				$errText = "Filename is invalid.";				
			}
			else {
				if (is_dir ($filename)) {
					$pi["dirname"] = $filename;
				}
				else {
					$pi = pathinfo ($filename);	
				}
							
				$filename2 = $pi["dirname"]."/".$newFilename;
        if (is_file ($filename2)) {
			   	$errText = "Filename just exists.";				      
        }
        else {
				
  				if (strpos ($newFilename,".")===false) {
  					if (isset ($pi["extension"]) && !empty ($pi["extension"]))
  						$filename2.=(".".$pi["extension"]);
  				}
  				$fh = fopen ($filename2, "w+");
  	
  				if ($fh) {
  					$filename = $filename2;
  					fclose ($fh);
  					$html.='
  					<script>
  					currentFilename = \''.$filename.'\';
  					parent.editor.location.href=\'editor.php?f=\'+currentFilename;
  					parent.output.location.href=currentFilename;
  					</script>
  					';
  					break;
					}
				}
			}
		}
		$html.= createFormNew ($filename, $newFilename);	
		$fCommand = true;
		break;

	case "rename":
		$newFilename = createSecurePath (trim (WSystem::getParam ("new_filename")));
		if (WSystem::isParam ("new_filename")) {
			if (empty ($newFilename)) {
				$errText = "Please insert a new filename.";
			}
			else
			if (!WFormat::check  ($newFilename, "filename", $errText)) {
				$errText = "Filename is invalid.";				
			}
			else {
				$pi = pathinfo ($filename);			
				$filename2 = $pi["dirname"]."/".$newFilename;
				if (strpos ($newFilename,".")===false) {
					if (isset ($pi["extension"]) && !empty ($pi["extension"]))
						$filename2.=(".".$pi["extension"]);
				}

				if (strcmp ($filename2, $filename)!=0 && is_file ($filename2)) {					
					$errText = "Filename just exists.";
				}
				else
				{
					if (rename ($filename, $filename2)) {
						$filename = $filename2;
						$html.='
						<script>
						currentFilename = \''.$filename.'\';
						parent.editor.location.href=\'editor.php?f=\'+currentFilename;
						parent.output.location.href=currentFilename;
						</script>
						';
						break;
					}
				}
			}
		}
		else {
			$pi = pathinfo($filename);
			$newFilename = $pi["basename"];		
		}
		$html.= createFormRename ($filename, $newFilename);	
		$fCommand = true;
		break;

	case "delete":
		if (is_file ($filename)) {
			if (unlink ($filename)) {
				$pi = pathinfo($filename);
				$filename = $pi["dirname"];			
			}
		}
		else {
			$pi = pathinfo($filename);
			$filename = $pi["dirname"];			
			
		}
		break;

}

// Get dir
$dir = ""; 
$selectedFile = "";
if (is_file ($filename)) {
	$pi = pathinfo ($filename);
	$dir = $pi["dirname"];
	$selectedFile = $pi["basename"];
}
else {
	$dir = $filename;
	if (USE_INDEX_FILES) {
		$selectedFile = getIndexFile ($dir);
	}
	$filename = $dir."/".$selectedFile;
}

// Context menus
$menu = new WTree ();
$menu->insertItem (array ("name" => "Rename", "cmd"=>"RENAME"));
$menu->insertItem (array ("name" => "Delete", "cmd"=>"DELETE"));		
$contextMenu = new WContextMenu ("contextmenu", $menu);

$menu2 = new WTree ();
$menu2->insertItem (array ("name" => "New file", "cmd"=>"NEW"));
$contextMenu2 = new WContextMenu ("contentmenu2", $menu2);


switch ($contextMenu->getCommand ()) {
	case "RENAME":
		$fCommand = true;
		$oldFilename = $contextMenu->getParam ();
		$pi = pathinfo ($oldFilename);
		$htmlForm = createFormRename ($oldFilename, $pi["basename"]);
		$script = '
			
			<script type="text/javascript">
			$(\'#content\').html (\''.WDB::escape ($htmlForm).'\');
			$(\'#focus_id\').focus ();
			</script>
			';		
		WUI::command (array ("evalScript"=>$script));
		exit;
		break;
	case "DELETE":
		$oldFilename = $contextMenu->getParam ();


		$script = '			
		<script type="text/javascript">			
		if (confirm ("Do you want to delete '.$oldFilename.'?")) {
			currentFilename = \''.$oldFilename.'\';
			window.location.href=\'navigator.php?cmd=delete&f=\'+currentFilename;			
		}
		</script>
			';		
		WUI::command (array ("evalScript"=>$script));
		
		exit;
		break;
};


switch ($contextMenu2->getCommand ()) {
	case "NEW":
		$fCommand = true;
		$oldFilename = $contextMenu2->getParam ();
		$htmlForm = createFormNew ($oldFilename);
		$script = '			
			<script type="text/javascript">
			$(\'#content\').html (\''.WDB::escape ($htmlForm).'\');
			$(\'#focus_id\').focus ();
			</script>
			';		
		WUI::command (array ("evalScript"=>$script));
		exit;
		break;
};



if (!$fCommand) {
	// Create file list
	$htmlFileList = "";
	$btNew = "";
	if (!is_dir ($dir)) {
		$htmlFileList = '<br /><div class="error msgText">'.htmlspecialchars ($_SERVER["DOCUMENT_ROOT"]."/".$dir).' does ot exists!</div>';
		$pi = pathinfo($dir);
		$dir = $pi["dirname"];			

	}
	else {
		$fileList = scandir ($dir);
		for ($z=0;$z<2;$z++) {
		  foreach ($fileList as $file) {  
		  	$fi = pathinfo ($file);  
				if ($file=="." || ($file==".." && $dir==SCRIPT_PATH))
					continue;	
		  	/*
		  	if (is_dir ($dir."/".$file) || $file=="." || $file=="..")
		  		continue;  
				*/
		  		
		  	$extra = "";
		  	if (strcmp ($selectedFile, $file)==0)
		  		$extra = ' marked ';
		  		
		  	$onmousedown = $contextMenu->getShowFunctionName ()."(event,this,'".$dir."/".$file."');";
		  	
		  	if (is_dir ($dir."/".$file)) {
		  		if ($z>0)
		  			continue;
		  		$newDir = $dir."/".$file;
			  	if ($file=="..")
			  	{
						$list = explode ("/", $dir);
						$newDir = "";
						for ($i=0;$i<count($list)-1;$i++) {
							if (!empty ($newDir))
								$newDir.="/";
							$newDir.=$list[$i];
						}
					}
					$htmlFileList.='<a class="dir" href="'.$file.'" onclick="window.location.href=\''.$_SERVER["PHP_SELF"].'?f='.$newDir.'\';return false;">'.$file.'</a>';		  	
			  }
		  	else {
		  		if ($z==0)
		  			continue;			  	
					$htmlFileList.='<a  class="'.getFileCSSClass ($fi["extension"]).$extra.'" oncontextmenu="return false;" onmousedown="'.$onmousedown.';return false;" href="'.$dir."/".$file.'" onclick="loadSourceFile(this);return false;">'.$file.'</a>';
			  }
		  }
		}
		
		$htmlFileList.=$contextMenu->__toString ().$contextMenu2->__toString ();
		$btNew = '<button onclick="window.location.href=\''.$_SERVER["PHP_SELF"].'?cmd=new&f=\'+currentFilename;return false;">New file</button>';
	}

	
	$disabled = "";
	if (!is_file ($filename)) {
		$disabled = ' disabled="disabled" ';	
	}
	$btRename = '<button class="edit_buttons" '.$disabled.' onclick="window.location.href=\''.WSystem::rebuildURI ($_SERVER["PHP_SELF"], array (), false, array ("cmd")).'?cmd=rename&f=\'+currentFilename;return false;">Rename</button>';
	$btDelete = '<button class="edit_buttons" '.$disabled.' onclick="if (confirm (\'Do you want to delete \'+currentFilename+\'?\')) window.location.href=\''.WSystem::rebuildURI ($_SERVER["PHP_SELF"], array (), false, array ("cmd")).'?cmd=delete&f=\'+currentFilename;return false;">Delete</button>';

		
	$html.= '
	<div class="toolbar"><span style="float:left;">'.$btNew.$btRename.$btDelete.'</span><button onclick="window.location.href=\''.WSystem::rebuildURI ($_SERVER["PHP_SELF"], array ("f"=>$dir), false, array ("cmd")).'\';return false;">Refresh</button></div>
	<div oncontextmenu="return false;" onmousedown="'.$contextMenu2->getShowFunctionName ()."(event,this,currentFilename)".'"return false;" id="file_list" class="file_list">
	'.$htmlFileList.'
	</div>';	
}

?>
<!DOCTYPE html>
<html lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title>WScript Editor</title>
<meta name="robots" content="noindex,nofollow" />
<script type="text/javascript" src="wlib/js/jquery/jquery.min.js"></script>
<script type="text/javascript" src="wlib/js/wlanguage_en.js"></script>
<script type="text/javascript" src="wlib/js/wsystem.js"></script>
<script type="text/javascript" src="wlib/js/wui.js"></script>
<script type="text/javascript" src="wlib/js/wpopup.js"></script>
<script type="text/javascript" src="wlib/js/wmenu.js"></script>
<link rel="stylesheet" type="text/css" href="css/style.css" media="all" />
<link rel="stylesheet" type="text/css" href="css/style_input.css" media="all" />
<link rel="stylesheet" type="text/css" href="css/style_navigator.css" media="all" />
<script>
currentFilename = '<?php echo $filename; ?>';
/*
parent.editor.location.href='editor.php?f='+currentFilename;
parent.output.location.href=currentFilename;
*/
function loadSourceFile (obj) {
	currentFilename = '<?php echo $dir;?>/'+obj.innerHTML;
	parent.editor.location.href='editor.php?f='+currentFilename;
	parent.output.location.href=currentFilename;
	$('#file_list > a').removeClass ('marked');
	$(obj).addClass ('marked');
	$('.edit_buttons').removeAttr ('disabled');
}

function setFullHeight () {
	$('#file_list').height ($(window).height()-$('.toolbar').height ());	
}

$(document).ready(function() 
{
	$(window).resize(function() {		
		setFullHeight ();
	});
	setFullHeight ();
});
</script>
</head>
<body>
<div id="content">
<?php echo $html; ?>
<script type="text/javascript">
$('#focus_id').focus ();
</script>
</div>
</body>
</html>