/*
 WLib Javascript Library
 Auhtor: Matthias.Wiede@web.de
 
 WMenu
 
*/

function WMenu (name, target, x, y, items, isHorizontal)
{
	/* Init vars */
	this.target = target;
	this.menuName = name;
	this.menuX = x;
	this.menuY = y;
	this.menuCreateTime = 50;
	this.menuCloseTime = 300;
	this.menuOffsetX = -5;
	this.menuOffsetY = 0;
	this.menuOffsetX2 = 0;
	this.menuOffsetY2 = 0;
	this.menuOpaque = 100; // 100=full opaque, 0=invisible
	this.menuItems = items;
	this.isHorizontal = isHorizontal;

	// Status vars
	this.menuListOpen = new Array ();
	this.menuItemIsSelected = false;
	this.menuCreateX = 0;
	this.menuCreateY = 0;
	this.menuCreateWidth = 0;
	this.menuCreateParents = new Array ();
	this.menuTimer = null;
	this.menuHorItemCnt = 0;

	this.createParentName = function (prefix, parents, offs) {
		var name = prefix;
		if (parents)
		{
			for (var i=1;i<parents.length+offs;i++)
				name+=("_"+parents[i]);
		}
		return name;
	}

	this.unmarkParentItem = function (menuName, name) 
	{
		var parents = name.split ("_");
		var parentItem = document.getElementById 
			(this.createParentName (menuName+"-item", parents, 0));
		if (parentItem)
			WSystem.setClass ("remove", parentItem, "active", "");	
	}
		
	this.getSubMenu = function (menuItems, parents, offs) {
		if (parents!=null && parents.length>1)
		{
			var linkURL = menuItems[parents[offs]-1][1];
			var subMenuItems = menuItems[parents[offs]-1][2];		
			var linkObj = menuItems[parents[offs]-1][3];
			if ((subMenuItems instanceof Array) && (offs+1)<parents.length) {
				var retArray = this.getSubMenu (subMenuItems, parents, offs+1, false);
				subMenuItems = retArray[0];
				linkURL = retArray[1];
				linkObj = retArray[2];
			}
	
			return new Array (subMenuItems, linkURL, linkObj);
		}
		return new Array (menuItems, "", null);
	}

	// Methods
	this.onMenuItemMouseOver = function(evt) 
	{
		var td = (evt.target) ? evt.target : evt.srcElement;
		WSystem.setClass ("add", td, "hover", "");
		var i = 0;
		var name = td.id;
		var parents = name.split ("-");
		var menu = null;
		if (parents.length==2)
			menu = WUI.menuList[parents[0]];
		parents = name.split ("_");

		if (menu!=null && parents.length>1) {
			name = menu.createParentName (menu.menuName, parents, -1);
			
			var table = document.getElementById (name);
			if (table)
			{
				var pos = (parents[parents.length-1]-1);
				
				var x = 0;
				var y = 0;
				var width = 0;
				if (parents.length==2 && menu.isHorizontal)  
				{
					// Sub menu for horizontal menu
					x = table.offsetLeft + td.offsetLeft  + menu.menuOffsetX2;					
					y = table.offsetTop  + td.offsetTop   + td.offsetHeight + menu.menuOffsetY2;


				}
				else
				{
					// Sub menu for vertical menu
					
					if (parents[1]==this.menuHorItemCnt)  {
						x = table.offsetLeft - menuOffsetX;
						y = table.offsetTop  + td.offsetTop   - menu.menuOffsetY;
					
					}
					else {
					
						x = table.offsetLeft + table.offsetWidth + menu.menuOffsetX;
						y = table.offsetTop  + td.offsetTop   + menu.menuOffsetY;
					}
				}
				
				menu.menuCreateX = x;
				menu.menuCreateY = y;
				menu.menuCreateParents = parents;
				menu.menuCreateWidth = width;
				if (menu.menuTimer) {
					clearTimeout(menu.menuTimer);
					menu.menuTimer = null;
				}
				menu.menuItemIsSelected = true;
				menu.menuTimer = setTimeout(function () { menu.timedCreateMenu() }, menu.menuCreateTime);
				
			}
		}
	}
	
	this.timedCreateMenu = function ()
	{

		var i=0;
		
		if (this.menuItemIsSelected)
		{
			var fJustExist = false;
			var dontDeleteName = this.createParentName (this.menuName, this.menuCreateParents,0)
			var length = this.menuListOpen.length;
			for (i=(this.menuCreateParents.length-2);i<length;i++) 
			{
				if (this.menuListOpen[i]) {
					if (this.menuListOpen[i].id==dontDeleteName) {
						fJustExist = true;
					}
					else 
					{
						var name = this.menuListOpen[i].id;
						this.unmarkParentItem (this.menuName, name);				
						this.target.removeChild (this.menuListOpen[i]);
						this.menuListOpen[i]=null;
					}
				}	
			}
			if (!fJustExist) {

				this.createMenu (this.target, this.menuCreateX, this.menuCreateY, this.menuCreateParents);	
			}
		}
	}
	
	this.timedCloseOpenMenus = function ()
	{
		if (this.menuItemIsSelected==false) {
			var length = this.menuListOpen.length;
			for (var i=length-1;i>=0;i--) {
				if (this.menuListOpen[i])
				{
					var name = this.menuListOpen[i].id;
					this.unmarkParentItem (this.menuName, name);
					this.target.removeChild (this.menuListOpen[i]);
					this.menuListOpen[i]=null;
				}
			}
		}
	}
	

	this.onMenuItemMouseOut = function (evt) {
	
		var td = (evt.target) ? evt.target : evt.srcElement;
		WSystem.setClass ("remove", td, "hover", "");
		// Check if mouse coords are outside of parent div
		mouseCoords = WSystem.getMouseCoords (evt);

		// Get true x/y of parent		
		var parentLeft=0,parentTop=0;
		var parentNode = td.parentNode;
		while (parentNode) {
			parentLeft+=parentNode.offsetLeft;
			parentTop+=parentNode.offsetTop;
			parentNode = parentNode.parentNode;
		}

		if (!(mouseCoords.x>parentLeft && 
			    mouseCoords.x<(parentLeft+td.parentNode.offsetWidth) && 
			    mouseCoords.y>parentTop && 
			    mouseCoords.y<(parentTop + td.parentNode.offsetHeight)))
		{

			var name = td.parentNode.id;
			var parents = name.split ("_");
			var menu = null;
			menu = WUI.menuList[parents[0]];
			if (menu!=null) {
			
				menu.menuItemIsSelected=false;
		
				if (menu.menuTimer)
				{
					clearTimeout(menu.menuTimer);
					menu.menuTimer = null;
				}
				menu.menuTimer = setTimeout(function () { menu.timedCloseOpenMenus() }, menu.menuCloseTime);
			}
		}		
	}
	
	this.onMenuMouseOver = function (evt) {
	
		var table = (evt.target) ? evt.target : evt.srcElement;
		var name = table.id;
		var parents = name.split ("_");
		var menu = null;
		menu = WUI.menuList[parents[0]];
		if (menu!=null) {
			if (menu.menuTimer)
			{
				clearTimeout(menu.menuTimer);
				menu.menuTimer = null;
			}		
		}
	}

	this.onMenuMouseOut = function (evt) {
	
		var table = (evt.target) ? evt.target : evt.srcElement;
		var name = table.id;
		var parents = name.split ("_");
		var menu = null;
		menu = WUI.menuList[parents[0]];
		if (menu!=null) {
		
			menu.menuItemIsSelected=false;
	
			if (menu.menuTimer)
			{
				clearTimeout(menu.menuTimer);
				menu.menuTimer = null;
			}
	
			menu.menuTimer = setTimeout(function () { menu.timedCloseOpenMenus() }, menu.menuCloseTime);
		}
		
	}
	
	
	this.onMenuItemClick = function (evt) 
	{
		if (evt.button==2)
			return false;
		var td = (evt.target) ? evt.target : evt.srcElement;
		var name = td.id;
		var parents = name.split ("-");
		var menu = null;
		if (parents.length==2)
			menu = WUI.menuList[parents[0]];
		parents = name.split ("_");
		if (menu!=null)
		{
			var linkURL = menu.getSubMenu (menu.menuItems, parents,1)[1];
			var linkObj = menu.getSubMenu (menu.menuItems, parents,1)[2];

			if (linkObj && linkObj.onclick) {
				linkObj.onclick (linkObj);
			}
			else
			if (linkURL!='' && linkURL.indexOf("javascript")==-1) {			
				if (linkObj && linkObj.target=='_blank')
					window.open (linkURL);
				else
					window.location.href=linkURL;
			}
			else
			if (linkURL!='') 
				eval (linkURL);
		}
		// g_fIgnoreDocMouseDown = true;
		return true;
	}
	
	this.closeMenu = function () {
	
		// Close open sub menus
		for (var i=0;i<this.menuListOpen.length;i++) {
			if (this.menuListOpen[i]) {		
					this.target.removeChild (this.menuListOpen[i]);
					this.menuListOpen[i] = null;
			}
		}
		this.menuOpenList=Array ();
		
		// Close main menu
		var name = this.createParentName (this.menuName, null, 0);
		var obj = document.getElementById (name);
		if (obj) {
			this.target.removeChild (obj);
		}
		
		WUI.menuList[this.name] = null;
	}
	
	this.createMenu = function (target, x, y, parents)
	{
		var name = this.createParentName (this.menuName, parents, 0);

		if (document.getElementById (name))
			return;
		var subMenu = this.getSubMenu (this.menuItems, parents,1)[0];

		if (subMenu instanceof Array)
		{ 
			// mark parent item
			var parentItem = document.getElementById 
				(this.createParentName (this.menuName+"-item", parents, 0));
			if (parentItem)
			{
				WSystem.setClass ("add", parentItem, "active", "");
			}
			
			// Create new sub menu
			var table = document.createElement("div");
			table.id = name;
			if (!parents && this.isHorizontal) 
				table.className = this.menuName+"_horizontal";
			else
				table.className = this.menuName;
						
			table.style.position = "absolute";
			table.style.left = x+"px";
			table.style.top = y+"px";
			
			if (this.menuCreateWidth!=0)
				table.style.width = this.menuCreateWidth+"px";
			
			WSystem.addEvent (table,'mouseout', this.onMenuMouseOut, false);
			WSystem.addEvent (table, 'mouseover', this.onMenuMouseOver, false);
			
			target.appendChild(table);
			
			if (!parents && this.isHorizontal) 
			{
				this.menuHorItemCnt = subMenu.length;
				for (var j = 0; j < subMenu.length; j++)
				{
					// Horizontal items
					var td = document.createElement ("span");
					td.className = "item";
					name =  this.createParentName (this.menuName+"-item", parents, 0);		
					name+=("_"+(j+1));
					td.id = name;
					
					
					WSystem.addEvent (td,'mouseover', this.onMenuItemMouseOver);
					WSystem.addEvent (td,'mouseout', this.onMenuItemMouseOut);
					WSystem.addEvent (td,'mousedown', this.onMenuItemClick);
					var text = document.createTextNode (subMenu[j][0]);
					if (subMenu[j][2] instanceof Array)
						td.className =  td.className + " hasItems";
			
					// Check marked style
					if (subMenu[j][3]) {
						if (WSystem.setClass('check', subMenu[j][3], 'marked','')) {
							td.className = td.className + " marked";
						}
					}
					td.appendChild(text);
					table.appendChild(td);
				}
				
			}
			else
			{
				if (parents && parents.length==2)
					WSystem.setClass ("add", table, this.menuName+"_first_sub", "");
				else
					WSystem.setClass ("add", table, this.menuName+"_sub", "");
				// setTransparency (table, menuOpaque);
				// Vertical items
				for (var j = 0; j < subMenu.length; j++)
				{
					var td = document.createElement ("div");
					td.className = "item";
					
					name =  this.createParentName (this.menuName+"-item", parents, 0);		
					name+=("_"+(j+1));
					td.id = name;
					
					WSystem.addEvent (td,'mouseover', this.onMenuItemMouseOver, false);
					WSystem.addEvent (td,'mouseout', this.onMenuItemMouseOut, false);
					WSystem.addEvent (td,'mousedown', this.onMenuItemClick, false);
					
					
					var text = document.createTextNode (subMenu[j][0]);

					if (subMenu[j][2] instanceof Array)
						td.className =  td.className + " hasItems";
					
					// Check marked style
					if (subMenu[j][3]) {
						if (WSystem.setClass('check', subMenu[j][3], 'marked','')) {
							td.className = td.className + " marked";
						}
					}

					td.appendChild(text);
					table.appendChild(td);

					// Set correct x position
					if (parents && parents[1]==this.menuHorItemCnt && parents.length>2) {
	
						table.style.left=(x-table.offsetWidth)+"px";
	
					}
				}
				
				// Set correct with of items
				var fullWidth = table.offsetWidth;
				if (table.currentStyle) {
					if (WSystem.ieVersion<8) {
						fullWidth-=parseInt (table.currentStyle.paddingRight);
						fullWidth-=parseInt (table.currentStyle.paddingLeft);
					}
					fullWidth-=WSystem.getBorderWidth (table, 'Right');
					fullWidth-=WSystem.getBorderWidth (table, 'Left');
				}
				var obj = table.firstChild;
				while (obj!=null) {
					var fullWidth2 = fullWidth;
					if (obj.currentStyle) {
						fullWidth2-=parseInt (obj.currentStyle.paddingRight);
						fullWidth2-=parseInt (obj.currentStyle.paddingLeft);
					
					}					
					obj.style.width = fullWidth2;
					obj = obj.nextSibling;
				}
				// table.style.width=fullWidth;
				
			}
			if (parents) {
				this.menuListOpen[parents.length-2]=table;
			}
		}
	}
	
	// Create menu
	
	this.createMenu (target, x, y);

	WUI.menuList[name]=this;
}
