<?php

/**

 WFrontendForm

**/


class WFrontendForm {

	private $layoutList = array ();
	private $id2ColIdxList = array ();
	private	$resultList = array ();	
	private $headerList = array ();
	private $data = array ();
	private $props = array ();
	private $errCnt = 0;
	private $profile_id = 0;
	private $html = "";
	private $html2 = "";
	private $fOK = false;
	private $headerStr = "";
	private $cmdValue = "send";
	
	private static $langText = array (
		"DE"=>array (
			"YES" => "JA",
			"NO" => "NEIN",
			"CHECK_MARKED_FIELDS" => "Bitte überprüfen Sie die markierten Felder.",
			"ENABLE_CHECKBOX" =>"Bitte klicken Sie die Checkbox an.",
			"SELECT_SOMETHING" => "Bitte wählen Sie etwas aus.",
			"FIELD_REQUIRED" => "Bitte füllen Sie das Feld aus.",
			"CLICK_ONCE" => "Bitte klicken Sie mindestens eine Antwort an.",
			"REQUIRED_FIELDS" => "Die mit dem Stern * markierten Felder müssen unbedingt ausgefüllt werden."
			),
		"EN"=>array (
			"YES" => "YES",
			"NO" => "NO",
			"CHECK_MARKED_FIELDS" => "Please check marked fields.",
			"ENABLE_CHECKBOX" =>"Please enable the checkbox.",
			"SELECT_SOMETHING" => "Please select something.",
			"FIELD_REQUIRED" => "Please fill out field.",
			"CLICK_ONCE" => "Please click at least one answer.",
			"REQUIRED_FIELDS" => "Fields marked with stars * are required."

			));			
	
	public static function getLangText ($key) {
		return WSystem::getArrayValue (self::$langText, LANGUAGE_CODE, "", $key);
		
	}
	
	public function __construct ($profile_id=0, $props=array()) {
		global $wdb;
		$this->props = $props;
		$this->layoutList = $wdb->queryTable (DB_TABLE_PREFIX."questionarylayout", "questionarylayout_id", "where profile_id=".$profile_id." and is_deleted=0 and is_visible=1 order by parent_questionarylayout_id, sort_pos"); 
			
		$this->id2ColIdxList = array ();
		list ($htmlForm, $this->html2, $js, $checkedCnt, $this->errCnt) = $this->createHTML ($this->layoutList);
		
		$extraVars = '';
		
		$this->cmdValue = "send";
		if (isset ($this->props["extra_vars"])) {
			foreach ($this->props["extra_vars"] as $key => $value) {
				if ($key=="cmd")
					$this->cmdValue = $value;				
				else
					$extraVars.='<input type="hidden" name="'.$key.'" value="'.htmlspecialchars ($value).'" />';
			}
		}
		
		
		
		$html =  '
		<form method="POST" action="'.WSystem::rebuildURI ($_SERVER["REQUEST_URI"], null, false, array ("cmd")).( (isset ($props["no_form_anchor"]) && $props["no_form_anchor"]) ? '' : '#form').'">
			'.$extraVars.'
			<input type="hidden" name="cmd" value="'.htmlspecialchars($this->cmdValue).'" /> 

			<div class="input_frame">
				<div class="input_frame_in">
				'.$htmlForm.$js.'
				</div>
				<div><input type="submit" value="'.htmlspecialchars (WSystem::getArrayValue ($this->props, "send_text", "Absenden")).'" class="form_button" /></div>
				<div class="font_small"><br />'.htmlspecialchars (self::getLangText ("REQUIRED_FIELDS")).'</div>
		
			</div>
		</form>';
		
		if (!count ($this->layoutList))
			$html="";

		
		$inputList = WSystem::getParam ("input");
		
		
		$this->fOK = (WSystem::getParam ("cmd")==$this->cmdValue && !$this->errCnt);
		if ($this->fOK)
		{		
			$resultStr = "";
			$this->headerStr = "";
			$colIdx = 0;

			$this->resultList = array ();	
			$this->headerList = array ();
			
			$col2IdList = array ();
			foreach ($this->id2ColIdxList as $id=>$colIdx) {
				$header = "";
				
				if ($id)
					$header = $wdb->getId ("select name from ".DB_TABLE_PREFIX."questionarylayout where questionarylayout_id=".$id, "name");
					
				if (!empty ($this->headerStr))
					$this->headerStr.=";";
				$this->headerStr.=("\"".utf8_decode ($header)."\"");
				$this->headerList[$colIdx]=$header;
				$this->resultList[$colIdx]="";
				
				$col2IdList[$colIdx]=$id;
			}
			$oldColIdx = 0;

			foreach ($inputList as $id => $valueList) {
				$rowIdx = 0;
				$valueStr = "";
				$dataField = "";
				foreach ($valueList as $id2=>$value) {

					if (isset ($this->id2ColIdxList[$id])) {
						$colIdx = $this->id2ColIdxList[$id];
						
						if (!isset ($this->headerList[$colIdx]))
							continue;
						
						if ($valueStr!="" && $value!="")
							$valueStr.=", ";
						$valueStr.=$value;	
						
						if (isset ($this->id2ColIdxList[$id2])) {							
							$this->resultList[$this->id2ColIdxList[$id2]]=$value;
						}
					}
					else {
						$colIdx = $this->id2ColIdxList[$id2];						
						
						if (!isset ($this->headerList[$colIdx]))
							continue;
						
						$this->resultList[$colIdx]=$value;

					}
				}
				
				// echo $id." / ".$valueStr." / OldColIdx= ".$oldColIdx." / ColId= ".$colIdx."<br />";
				
				if (!empty ($dataField) && $valueStr!="") {
					$this->resultList[$colIdx]=$valueStr;
				}
				
				if (!empty ($dataField))
					$this->data[$dataField]=trim ($valueStr);

			}
			
			// Set data			

			foreach ($this->resultList as $colIdx => $value) {
				$value = trim ($value);
			 	$dataField = $this->layoutList[$col2IdList[$colIdx]]["data_field"];
			 	$dataType = $this->layoutList[$col2IdList[$colIdx]]["data_type"];
				if (!empty ($dataField)) {
					$this->data[$dataField]=WFormat::parse ($value, $dataType, $errText);			
				
				}
			}
		
		}
		else {
			if ($this->errCnt>0)
				$html='<p class="error error_frame">'.$this->getLangText ("CHECK_MARKED_FIELDS").'</p>'.$html;
		}

		if (!empty ($html))
			$this->html = ((isset ($props["no_form_anchor"]) && $props["no_form_anchor"]) ? '' : $props["no_form_anchor"].'<a name="form"></a>').'<div>'.$html.'</div>';
		else
			$this->html = $html;
	}	
	
	
	private function createHTML ($layoutList, $parent_layout_id=0, $js="", $deep=0, $errCnt=0, $colIdx=0, $parentListVisible=true) {
	
		$html = $html2 = "";
		$checkedCnt = 0;
		$fSend = WSystem::getParam ("cmd")==$this->cmdValue;
	
		$parentData = NULL;
		if ($parent_layout_id)
			$parentData = $layoutList[$parent_layout_id];
	
		$errText = "";
	
		foreach ($this->layoutList as $layout_id => $data) {
			if ($data["parent_questionarylayout_id"]!=$parent_layout_id)
				continue;
			
			
			$text = $data["name"];
			
			
	
			$fieldId = "input".$layout_id;
			$inputList = WSystem::getParam ("input");
			
	//	print_r ($inputList);
			$fieldName = "input[".$parent_layout_id."]";		
			$fieldValue = "";	
			if ($data["layout_type_id"]!=20)  {
				if (isset($inputList[$parent_layout_id][$layout_id]))
					$fieldValue = $inputList[$parent_layout_id][$layout_id];
				else
				if (!$fSend)
				{				
				
					if (isset ($this->props["default_values"][$data["data_field"]]))
						$fieldValue = $this->props["default_values"][$data["data_field"]];					
					else					
						$fieldValue = $data["default_value"];
					$fieldValue = WFormat::format ($fieldValue, $data["data_type"]);

				}
			}
			else {
				if (isset($inputList[$parent_layout_id][0]))
					$fieldValue = $inputList[$parent_layout_id][0];
				else
				if (!$fSend)
				{

					$parentData = $this->layoutList[$parent_layout_id];
				
					if (isset ($this->props["default_values"][$parentData["data_field"]]))
						$fieldValue = $this->props["default_values"][$parentData["data_field"]];					
					else
						$fieldValue = $data["default_value"];
					$fieldValue = WFormat::format ($fieldValue, $parentData["data_type"]);

				}
			}
			
			$fParentVisible = true;
	
			$subListStyle = ($data["is_show_children"] ? ' style="display:none;" ' : '');
			$subListVisible = !$data["is_show_children"] && $parentListVisible;
			$fRequired = $data["is_required"];
			
			if ($fRequired)
				$text.=" *";

			$imgTag = "";
			if (!empty ($data["file"])) {
				$filename = '/images/form/'.$data["file"];
				$picsize = getimagesize(ROOT_PATH.'/'.$filename);
				if ($picsize && $picsize[0]>40) {
					$imgTag.='<a class="input_img" href="/images/form/'.$data["file"].'" onclick="showVideoPopup (\''.$filename.'\', '.$picsize[0].', '.$picsize[1].', \''.$text.'\',null,null);return false;" target="_blank"><img src="'.$filename.'" style="vertical-align:middle;" alt="" width="40" height="40" /></a>&nbsp;&nbsp;';

				}
				else {
					$imgTag.='<label for="'.$fieldId.'"><img src="'.$filename.'" style="vertical-align:middle;" alt="" width="40" height="40" /></label>';
				}
			
			}

			
			switch ($data["layout_type_id"]) {
				case 1:
					$html.='<h3>'.htmlspecialchars ($text).'</h3>';
					$html2.='<p>'.htmlspecialchars (trim(rtrim ($text, "*"))).':</p>';
					$checkedCnt++;
					break;
				case 10:
	
	
					switch ($data["data_type"]) {
						case "b":
							$value = 1;
							break;
	
						default:
							$value = $data["name"];
							if (!empty ($data["data_value"])) {
								$value = $data["data_value"];						
							}
							break;
					}			
					
					
					

					
					$extraClass = "";
					if ($parentData && $parentData["col_width"]>0) {
						$extraClass = " col_".((int) $parentData["col_width"])." ";
					}
					
					$errClass = "";
					if ($fieldValue==$value)
						$checkedCnt++;
					else 
					if ($fRequired && !$parent_layout_id && $fSend) {
						$errText = self::getLangText ("ENABLE_CHECKBOX");
						$errClass = " error";					
					}	
					if (!$data["is_show_children"]) {
							$html.='<div class="input_row'.$extraClass.$errClass.'">';
					}

					if (!empty ($errText)) {
						$html.='<div class="input_error">'.$errText.'</div>';
						$errCnt++;			
					}
					
					if ($data["is_title_text"])
						$text = "";
					
					$onClick = "";
					if (!empty ($data["extra_class"]))
						$onClick = ' onclick="var e = arguments[0] || window.event; e.stopPropagation();" ';


					$in=$imgTag.'<input class="input_checkbox" type="checkbox" '.$onClick.' name="'.$fieldName.'['.$layout_id.']" id="'.$fieldId.'" '.($fieldValue==$value ? "checked=\"checked\"" : "").' value="'.htmlspecialchars ($value).'" /><label for="'.$fieldId.'">'.((!empty ($data["name2"]) && !$data["is_tooltext"]) ? str_replace (array ("<p>","</p>"), array ("", ""), $data["name2"]).($fRequired ? " *": "") : str_replace ("|", "&shy;", htmlspecialchars ($text))).'</label>';

					if ($data["is_tooltext"])
							$in='<span class="tooltip"><span class="tooltiptext">'.$data["name2"].'</span>'.$in.'</span>';			
					if (!empty ($data["extra_class"]))
							$in='<span class="'.$data["extra_class"].'" onclick="var $checkbox = $(this).find(\':checkbox\');$checkbox.prop(\'checked\', !$checkbox.prop(\'checked\'));">'.str_replace ("<label for=\"", "<label for=\"_", $in).'</span>';			
						
			
					$html.=$in;
					
					if ($data["is_show_children"]) {
						$html.='<div class="input_sublist_margin"></div>';
					}
					else {
						$html.='</div>';
					}
					
					if ($fieldValue==$value) // Only if checked
						$html2.='<b>'.str_replace ("|", "", htmlspecialchars (rtrim ($text, "*"))).($data["is_tooltext"] ? " ".strip_tags (str_replace ("<br />", ",", $data["name2"])): "").'</b><br />'; // ': <b>'.(($fieldValue==$value) ? self::getLangText("YES") : self::getLangText ("NO")).'</b><br />';
					
					if ($data["is_show_children"]) {
						$js.='<script type="text/javascript">$("input[name='.str_replace (array ("[","]"), array ("\\\\[", "\\\\]"), $fieldName).'\\\\['.$layout_id.'\\\\]]:checkbox").change(function() {  if (!$(\'#'.$fieldId.'\').is(":checked")) { $(\'#sublist'.$layout_id.'\').hide ();} else { $(\'#sublist'.$layout_id.'\').show (); }});</script>';
						
						if ($fieldValue==$data["name"] || $fieldValue==$value) {
							$subListStyle=" style=\"display:block;\" ";
							$subListVisible = true;
						}
					
					}
	
					$colIdxId = $parent_layout_id;
					if (!$colIdxId)
						$colIdxId = $layout_id;
					if (!isset ($this->id2ColIdxList[$colIdxId])) {
						$this->id2ColIdxList[$colIdxId]=$colIdx;
						$colIdx++;
					}
					
					
					break;
	
				case 20:
					
					$colIdxId = $parent_layout_id;
					if (!$colIdxId)
						$colIdxId = $layout_id;
					if (!isset ($this->id2ColIdxList[$colIdxId])) {
						$this->id2ColIdxList[$colIdxId]=$colIdx;
						$colIdx++;
					}
	
					$value = $data["name"];
					if ($data["data_value"]!="") {
						$value = $data["data_value"];						
					}
					

					if ($fieldValue==$value)
						$checkedCnt++;



					$extraClass = "";
					if ($parentData && $parentData["col_width"]>0) {
						$extraClass = " col_".((int) $parentData["col_width"])." ";
					}
	
					if (!$data["is_show_children"]) {
							$html.='<div class="input_row'.$extraClass.'">';
					}
					
					if ($data["is_title_text"])
						$text = "";

					$html.=$imgTag.'<input class="input_radio" type="radio" name="'.$fieldName.'[0]" id="'.$fieldId.'" '.($fieldValue==$value ? "checked=\"checked\"" : "").'value="'.htmlspecialchars ($value).'" /><label for="'.$fieldId.'">'.htmlspecialchars ($text).'</label>';

					if ($data["is_show_children"]) {
						$html.='<div class="input_sublist_margin"></div>';
					}
					else {
						$html.='</div>';
					}

					if ($fieldValue==$value)
						$html2.='<b>'.htmlspecialchars (rtrim ($text, "*")).'</b><br />';


					if ($data["is_show_children"]) {
						$js.='<script type="text/javascript">$("input[name='.str_replace (array ("[","]"), array ("\\\\[", "\\\\]"), $fieldName).'\\\\[0\\\\]]:radio").change(function() {  if (!$(\'#'.$fieldId.'\').is(":checked")) { $(\'#sublist'.$layout_id.'\').hide ();} else { $(\'#sublist'.$layout_id.'\').show (); }});</script>';
						
						if ($fieldValue==$value || $fieldValue==$value) {
							$subListStyle=" style=\"display:block;\" ";
							$subListVisible = true;
						}
					
					}
					break;
	
	
				case 25:
					$htmlErr = "";
					$errClass = "";
					if ($fRequired)
					{
						if (!empty ($fieldValue))
							$checkedCnt++;		
						else			
						if ($parentListVisible && $fSend) {						
							$errText = self::getLangText ("SELECT_SOMETHING");
							$htmlErr='<div class="input_error">'.$errText.'</div>';
							$errClass = " error";
							$errCnt++;
						}				
					}
					else {
						$checkedCnt++;
					}
	 
	
					if (!isset ($this->id2ColIdxList[$layout_id])) {
						$this->id2ColIdxList[$layout_id]=$colIdx;
						$colIdx++;
					}


					
					$valueList = explode (";", $data["dropdown_values"]);
					
					$countryList = array ();

									
					$htmlOptions = "";
					$htmlOptions.='<option value="">---</option>';
					$selValue = "";

					
					// List from file
					if (($p=strpos ($data["dropdown_values"], "$"))!==false && $p==0) {
						$fh = fopen (ROOT_PATH."/".ltrim ($data["dropdown_values"], "$"), "r");
						if ($fh) {
							$idx = 0;
							while (!feof($fh)) {				
						    $line = trim (fgets($fh), "\r\n ");
						    if (empty ($line))
						    	continue;
						    	
					    	$name = "";
					    	$line = utf8_encode ($line);
						    if (strpos ($line, ";")!=false)						    
						   		list ($value2, $name) = explode (";", $line);
						    else {
						    	$value2 = trim ($line);
						    }
						    if (empty ($name))
						    	$name=$value2;
						    // $countryList[trim ($code)]=trim (utf8_encode ($name));	    
						    $value = trim ($name);
								if (!strcmp ($fieldValue, $value2))
									$selValue = $value;
									
							
								$htmlOptions.='<option '.(!strcmp($fieldValue, $value2) ? "selected=\"selected\"" : "").' value="'.htmlspecialchars ($value2).'">'.$value.'</option>';
							}
							fclose ($fh);		
						}
					}
					else {

						foreach ($valueList as $value) {
						
							if (strpos ($value,"=")!==false) {
								list ($value2, $value) = explode ("=", $value);
							}
							else
							{
								$value2 = $value;
							}
							if ($fieldValue==$value2)
								$selValue = $value;
							$htmlOptions.='<option '.($fieldValue==$value2 ? "selected=\"selected\"" : "").' value="'.htmlspecialchars ($value2).'">'.$value.'</option>';
						}
					}
					
					$style = '';
					if ($data["width"])
						$style = ' style="width:'.$data["width"].'px;" ';

					
					$extraClass = "";
					if (!empty ($data["extra_class"]))
						$extraClass=" ".$data["extra_class"];
	

					$html.='<div class="input_row'.$extraClass.'">'.$htmlErr.'<span class="input_field_desc'.$errClass.'">'.htmlspecialchars ($text).'</span><select '.$style.' class="input_select" name="'.$fieldName.'['.$layout_id.']" id="'.$fieldId.'">'.$htmlOptions.'</select></div>';

					$html2.=htmlspecialchars (rtrim ($text, "*")).': <b>'.htmlspecialchars ($selValue).'</b><br />';
					break;
	
				case 30:
				case 31:
					$fieldValue = trim ($fieldValue);
					$htmlErr = "";
					$errClass = "";
					if ($fRequired)
					{
						if (!empty ($fieldValue))
							$checkedCnt++;
						else
						if ($parentListVisible && $fSend) {
							$errText = self::getLangText ("FIELD_REQUIRED"); 
							$htmlErr='<div class="input_error">'.$errText.'</div>';
							$errClass = " error";
							$errCnt++;
							
						}
					}
					else {
						$checkedCnt++;
					}
					
					if ($fSend) {
						// Check datatype
						if (!WFormat::check ($fieldValue, $data["data_type"], $errText2)) {
							$errText = $errText2;
							$htmlErr='<div class="input_error">'.$errText.'</div>';
							$errCnt++;
						}
					}
					
					$style = '';
					if ($data["width"] || $data["height"])
						$style = ' style="width:'.$data["width"].'px;" ';
	
	
					$extraClass = "";
					if ($parentData && $parentData["col_width"]>0) {
						$extraClass = " col_".((int) $parentData["col_width"])." ";
					}
					
					if (!empty ($data["extra_class"]))
						$extraClass.=" ".$data["extra_class"];
	
	
	
					$html.='<div class="input_row'.$extraClass.'">'.$htmlErr.'<span class="input_field_desc'.$errClass.'">'.htmlspecialchars ($text).'</span><input '.$style.' class="input_textfield" spellcheck="false" type="'.($data["layout_type_id"]==31 ? 'password' : 'text').'" name="'.$fieldName.'['.$layout_id.']" id="'.$fieldId.'" value="'.htmlspecialchars (($data["layout_type_id"]==31 ? '' : $fieldValue)).'" /></div>';

					if (!empty ($fieldValue))
						$html2.=htmlspecialchars (rtrim ($text, "*")).': <b>'.htmlspecialchars ($fieldValue).'</b><br />';

					
					if (!isset ($this->id2ColIdxList[$layout_id])) {
						$this->id2ColIdxList[$layout_id]=$colIdx;
						$colIdx++;
					}
					break;
	
				case 35:
					$htmlErr = "";
					$errClass = "";
					if ($fRequired)
					{
						if (!empty ($fieldValue))
							$checkedCnt++;
						else
						if ($parentListVisible && $fSend) {
							$errText =  self::getLangText ("FIELD_REQUIRED"); // "Bitte füllen Sie das Feld aus.";
							$htmlErr='<div class="input_error">'.$errText.'</div>';
							$errClass = " error";
							$errCnt++;
							
						}
					}
					else {
						$checkedCnt++;
					}
					
					$style = '';
					if ($data["width"] || $data["height"])
						$style = ' style="width:'.$data["width"].'px;height:'.$data["height"].'px;" ';

					$extraClass = "";
					if (!empty ($data["extra_class"]))
						$extraClass.=" ".$data["extra_class"];


					$html.='<div class="input_row'.$extraClass.'">'.$htmlErr.'<span class="input_field_desc'.$errClass.'">'.htmlspecialchars ($text).'</span><textarea '.$style.' class="input_textarea" name="'.$fieldName.'['.$layout_id.']" id="'.$fieldId.'">'.htmlspecialchars ($fieldValue).'</textarea></div>';
		
					if (!empty ($fieldValue))
						$html2.='<p>'.htmlspecialchars (rtrim ($text, "*")).':</p><p><b>'.nl2br (htmlspecialchars ($fieldValue)).'</b></p>';
						
					if (!isset ($this->id2ColIdxList[$layout_id])) {
						$this->id2ColIdxList[$layout_id]=$colIdx;
						$colIdx++;
					}
					break;
					
				case 99:
					$html.='<input type="hidden" name="'.$fieldName.'['.$layout_id.']" id="'.$fieldId.'" value="'.htmlspecialchars ($fieldValue).'" />';
					if (!isset ($this->id2ColIdxList[$layout_id])) {
						$this->id2ColIdxList[$layout_id]=$colIdx;
						$colIdx++;
					}
					$checkedCnt++;
					break;
			
				default:
					if (!empty ($data["name2"])) {
						$html.=$data["name2"];
						// $html2.=rtrim ($data["name2"], "*");
					
					}
					else {
						$html.='<div class="input_raw_text"><b>'.nl2br (htmlspecialchars ($text)).'</b></div>';
//						if ($data["has_children"])

						$html2.='<div class="input_raw_text">'.nl2br (htmlspecialchars (rtrim ($text, "*"))).'</div>';
					}
					$checkedCnt++;
					break;			
			}
				
			if ($data["has_children"]) {
				$errCntOld = $errCnt;
				list ($htmlForm, $htmlLocked, $js, $checkedCnt2, $errCnt, $colIdx, $errTextSub) = $this->createHTML ($this->layoutList, $layout_id, $js, $deep+1, $errCnt, $colIdx, $subListVisible);
				if (!$checkedCnt2 && WSystem::getParam ("cmd")==$this->cmdValue && $subListVisible) {
					if (empty ($errTextSub) && ($fRequired || ($parentData && $parentData["is_required"]))) {
						$htmlForm='<div class="input_error">'.self::getLangText ("CLICK_ONCE").'</div>'.$htmlForm;
						$errCnt++;
					}
				}
				
				$offset = 20*($deep);
				$html.='<div class="input_sublist" id="sublist'.$layout_id.'"'.$subListStyle.'><div style="padding-left:'.$offset.'px;">'.$htmlForm.'</div></div>';	
				
				if ($subListVisible) {
					$html2.='<div style="margin-bottom:15px;padding-left:'.$offset.'px;">'.$htmlLocked.'</div>';	
				}
				
			}	
		}
		
		return array ($html, $html2, $js, $checkedCnt, $errCnt, $colIdx, $errText);
	}
	

	// ROOT_PATH."/umfrage".($profile_id+1).".csv"
	public function saveResultAsCSV ($filename) {
		
		$resultStr = "";
		foreach ($this->resultList as $colIdx => $value) {
			if (!empty ($resultStr))
				$resultStr.=";";
			$resultStr.="\"".utf8_decode ($value)."\"";
		}
		
		$fExists = is_file ($filename);
		$fh = fopen ($filename, "a+");
		if (!$fExists)
			fwrite ($fh, "Zeit;".$this->headerStr."\r\n");
		fwrite ($fh, strftime("%Y-%m-%d %H:%M:%S", time ()).";".$resultStr."\r\n");
		fclose ($fh);	
	}
	
	public function getResultAsHTML () {
		
		$html = "";
		foreach ($this->headerList as $colIdx => $header) {
			$html.=
			'<tr>
				<td style="vertical-align:top;padding-right:10px;">'.htmlspecialchars (rtrim ($header, "*")).'</td>
				<td style="vertical-align:top;">'.nl2br (htmlspecialchars (WSystem::getArrayValue ($this->resultList, $colIdx, "&nbsp;"))).'</td>
			</tr>
			';
		}
		if (!empty ($html)) {
			return '<table>'.$html.'</table>';
		}
		return "";
	}
	
	public function isOK () {
		return $this->fOK;
	}
	
	public function getErrCnt () {
		return $this->errCnt;
	}

	public function getHTML () {
		return $this->html;
	}

	public function getHTMLLocked () {
		return $this->html2;
	}

	public function getResultList () {
		return $this->resultList;
	}
	
	public function getHeaderList () {
		return $this->headerList;
	}
	
	public function getData () {
		return $this->data;
	}
		
	public function __toString () {
		return $this->html;
	}	
}


?>