<?php

/**

 WHTML
 HTML page

**/

class WHTML
{
	const DOCTYPE_HTML401 = 1;
	const DOCTYPE_HTML401_STRICT = 2;
	const DOCTYPE_XHTML10 = 3;
	const DOCTYPE_XHTML10_STRICT = 4;
	const DOCTYPE_XHTML11 = 5;
	
	private $docType = self::DOCTYPE_XHTML10;
	private $title = "";
	private $head = "";
	private $body = "";
	private $cssList = array();
	private $jsList = array();
	private $onLoadJS = "";
	
	public function __construct () {
	}
	
	public function __destruct () {
	}
	
	public function setDocType ($docType) {
		$this->docType = $docType;
	}

	public function setTitle ($title) {
		$this->title = $title;
	}
	
	public function setWLIBDefaults () {		
		$this->setDocType (WHTML::DOCTYPE_HTML401);


		$this->addJSFilename ("../wlib/js/jquery/jquery.min.js");
		$this->addJSFilename ("../wlib/js/jquery/jquery.lockSubmit.js");
		$this->addJSFilename ("../wlib/js/jquery/jquery.cookie.js");
		$this->addCSSFilename("../wlib/js/jquery/tooltip/jquery.tooltip.css");
		$this->addJSFilename ("../wlib/js/jquery/tooltip/jquery.tooltip.js");


	
		$this->addJSFilename ("../wlib/js/wlanguage_".strtolower (LANGUAGE_CODE).".js");
		$this->addJSFilename ("../wlib/js/wsystem.js");
		$this->addJSFilename ("../wlib/js/wui.js");
		$this->addJSFilename ("../wlib/js/wmenu.js");
		$this->addJSFilename ("../wlib/js/wpopup.js");
		$this->addJSFilename ("../wlib/js/wdragable.js");
		$this->addJSFilename ("../wlib/js/wsplitter.js");

		
		
		$this->addCSSFilename("../wlib/js/videojs/video-js.min.css");
		$this->addJSFilename ("../wlib/js/videojs/video.min.js");
		$this->addJSFilename ("../wlib/js/emff/swf.js");

		if (!defined ("NO_CKEDITOR")) {
			// CKEditor
			if (is_dir (WLIB_PATH."/js/ckeditor")) {
				$this->addJSFilename ("../wlib/js/ckeditor/ckeditor.js");
			}
		}
		
		$this->addJSCode ('tinyMCE=null;');
		if (!defined ("NO_TINYMCE")) {
			// TinyMCE			
			if (is_dir (WLIB_PATH."/js/tinymce")) {
				$this->addJSFilename ("../wlib/js/tinymce/tiny_mce.js");
				$this->addJSCode ('
				function openKCFinder(field_name, url, type, win) {
				    tinyMCE.activeEditor.windowManager.open({
				        file: \'/wlib/js/kcfinder/browse.php?opener=tinymce&type=\' + type,
				        title: \'KCFinder\',
				        width: 700,
				        height: 500,
				        resizable: "yes",
				        inline: true,
				        close_previous: "no",
				        popup_css: false
				    }, {
				        window: win,
				        input: field_name
				    });
				    return false;
				}
				
				function tinyMCEChanged () {
					if (tinyMCE.activeEditor.isDirty()) {				
						var i = tinyMCE.activeEditor.id;
	
						var id =$(\'#\'+i).closest(\'form\').parent ().parent ().attr (\'id\');
						WUI.setParentSubmitLocked (id);
					}
				}
		
				tinyMCE.init({
							mode : "none",
							theme : "advanced",
							plugins : "safari,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template",
							theme_advanced_buttons1 : "save,newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,styleselect,formatselect",
							theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,|,insertdate,inserttime,preview,|,forecolor,backcolor",
							theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,iespell,media,advhr,|,print,|,ltr,rtl,|,fullscreen",
							theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,|,cite,abbr,acronym,del,ins,attribs,|,visualchars,nonbreaking,template,pagebreak",
							theme_advanced_toolbar_location : "top",
							theme_advanced_toolbar_align : "left",
							theme_advanced_statusbar_location : "bottom",
							theme_advanced_resizing : true,
							content_css : \'css/ckeditor.css\',
							setup : function(ed) {
						      ed.onInit.add(function(ed) {
						          WUI.onWindowResize ();
						          jQuery (\'#\'+ed.id).parent().show ();
						      });
						   },
							style_formats : [
							'.WSystem::getConf ("tinymce_combo_styles").'
							],
							relative_urls : false,
							file_browser_callback: \'openKCFinder\',
						  onchange_callback : "tinyMCEChanged" 
						});	
				');
			}
		}
		
		if (!defined ("NO_MODERN_UPLOADER")) {
			$this->addCSSFilename ("../wlib/php/utils/uploader2/fileuploader.css");
			// Language specific stuff
			if (LANGUAGE_CODE=="DE") {
				$this->addJSFilename ("../wlib/php/utils/uploader2/fileuploader.js");	
				
			}
			else {
				$this->addJSFilename ("../wlib/php/utils/uploader2/fileuploader_en.js");	
				
			
			}
		}		
			
	}
	
	public function addCSSFilename ($filename, $fBody=false, $fInsertDirect=false) {
		array_push ($this->cssList, 
			array ("filename" => $filename, "fBody" => $fBody, "code" => "", "fInsertDirect" => $fInsertDirect));
	}

	public function addCSSCode ($code, $fBody=false) {
		array_push ($this->cssList, array ("filename" => "", "fBody" => $fBody, "code" => $code));
	}

	public function addJSFilename ($filename, $fBody=false, $fInsertDirect=false) {
		array_push ($this->jsList,
		 array ("filename" => $filename, "fBody" => $fBody, "code" => "", "fInsertDirect" => $fInsertDirect));
	}

	public function addJSCode ($code, $fBody=false) {
		array_push ($this->jsList, array ("filename" => "", "fBody" => $fBody, "code" => $code));
	}
	
	public function setOnLoadJS ($code) {
		$this->onLoadJS = $code;
	}

	public function appendHead ($head) {
		$this->head.=$head;
	}

	public function setHead ($head) {
		$this->head=$head;
	}
		
	public function appendBody ($body) {
		$this->body.=$body;
	}
	
	public function setBody ($body) {
		$this->body=$body;
	}	
	
	public function output () {		
	
		echo $this->getHTML ();
	}
	
	public function getHTML () {
		
		$html = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"\n".
        "\"http://www.w3.org/TR/html4/loose.dtd\">\n";
				
		switch ($this->docType) {
				
			case self::DOCTYPE_HTML401_STRICT:
				$html = 
					"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"\n".
						"\"http://www.w3.org/TR/html4/strict.dtd\">\n";
				break;
		
			case self::DOCTYPE_XHTML10:
				$html = 
					"<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\"\n".
     				"\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n";
				break;

			case self::DOCTYPE_XHTML10_STRICT:
				$html = 
					"<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"\n".
     				"\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n";
				break;
				
			case self::DOCTYPE_XHTML11:
				$html.=
					"<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.1//EN\"\n".
    				"\"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd\">\n";
				break;
		}
		
		$html.=
			"<html>\n".
			"<head>\n".
			"<title>".htmlspecialchars ($this->title)."</title>\n".
			"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\n".
			$this->head.
			$this->createCSS ().
			$this->createCSS (true).
			"</head>\n";
		if (!empty ($this->onLoadJS)) {
			$html.=
			"<body onload=\"".$this->onLoadJS."\">\n";
		}
		else {
			$html.=			
			"<body>\n".			
			$this->createJS ();		
		}
		$html.=
			$this->createJS (true).
			$this->body."\n".
			"</body>\n".
			"</html>";
		return $html;
	}

	public function __toString () {
		return $this->getHTML ();
	}
	
	private function createCSS ($fBody=false) {
		$html = "";
		foreach ($this->cssList as $data) {
			if (!empty ($data["filename"]) && $data["fBody"]==$fBody) {
				if (!$data["fInsertDirect"]) {
					$html.="<link rel=\"stylesheet\" type=\"text/css\" href=\"".$data["filename"]."\">\n";	
				}
				else {

					$html.="<style type=\"text/css\">\n".file_get_contents($data["filename"])."\n</style>\n";
				}
			}
			else
			if (!empty ($data["code"])) {
				$html.="<style type=\"text/css\">\n".$data["code"]."\n</style>\n";			
			}
		}
		return $html;
	}

	private function createJS ($fBody=false) {
		$html = "";
		foreach ($this->jsList as $data) {
			if (!empty ($data["filename"]) && $data["fBody"]==$fBody) {
				if (!$data["fInsertDirect"]) {
					$html.="<script type=\"text/javascript\" src=\"".$data["filename"]."\"></script>\n";	
				}
				else {
					$html.="<script type=\"text/javascript\">\n".file_get_contents($data["filename"])."\n</script>\n";
				}
			}
			else
			if (!empty ($data["code"]) && $data["fBody"]==$fBody) {
				$html.="<script type=\"text/javascript\">\n".$data["code"]."\n</script>\n";			
			}
		}
		return $html;
	}
};

?>