<?php

/**

 WMenu

**/


class WMenu extends WUIElement
{
	private $tree = NULL;
	private $className = "";
	
	public function __construct ($id, $tree) {
		$this->tree = $tree;
		$this->className = $id;
		parent::__construct ($id);
	}
	
	public function __destruct () {
	
	}

	private function renderList ($parentId) {

		$html = "";
		$itemList = $this->tree->getItems ($parentId);
		if (!$itemList)
			return $html;
		foreach ($itemList as $itemId => $itemData) {		
				$html.="<li>";
				$onclick = $class = $href = $target = "";
				if (isset ($itemData["view"]) && $itemData["view"]!="")
					$onclick = 'onclick="WUI.loadPage (\''.WSystem::getRequestURI (array ("view"=>$itemData["view"]), true).'\', \'cmd=init\');return false;"';

				if (isset ($itemData["url"]))
					$href=$itemData["url"];

				if (isset ($itemData["target"]))
					$target = 'target="'.$itemData["target"].'"';
				
				if (isset ($itemData["is_marked"]) && $itemData["is_marked"])
					$class.=' marked';
					
				if (empty ($href) && empty ($onclick))
					$onclick=' onclick="return false;"';

				$html.='<a '.$target.' class="'.$class.'" href="'.$href.'" '.$onclick.'>'.$itemData["name"].'</a>';
				$html.=$this->renderList ($itemId);	
				$html.="</li>";
		}
		
		$html = '<ul>'.$html.'</ul>';
		return $html;
	}

	public function renderElement ()
	{
		
		// Items
		$this->html='<div id="items-'.$this->id.'" style="display:none;">'.$this->renderList (0).'</div>';
		
		$this->html.='<div class="'.$this->className.'" id="'.$this->id.'"></div>';
		
		// Functions
		$this->html.='
			<script type="text/javascript">
					
			var ulObj = document.getElementById ("items-'.$this->id.'").firstChild;	
			var menuItems = WUI.createMenuItemsFromULStruct (ulObj);				
			var menu = new WMenu (\''.$this->className.'\', document.getElementById(\''.$this->id.'\'), 0, 0, menuItems, true);

			</script>
		';
	}
	
	public function getCreateFunctionName () {
		return "createMenu_".$this->id;
	}
	
	public function getCommand () {
		return WSystem::getParam ($this->id."_cmd");
	}
}


?>