<?php

/**

 WUITreeview

**/


abstract class WTreeview extends WUIElement
{
	protected $tree = NULL;
	protected $contextMenu = NULL;
	protected $itemContextMenu = NULL;
	protected $name = "Start";
	protected $iconMap = array();

	
	public function __construct ($id, $name, $menu, $menu2) {
		$this->name = $name;
		$this->contextMenu = $menu;
		$this->itemContextMenu = $menu2;		
		parent::__construct ($id);
		$this->loadTree ();
	}
	
	public function __destruct () {
	
	}
	
	/* Overwritten by child */
	public abstract function loadTree ();
	public abstract function saveTree ();
	public abstract function onTreeEvent ($cmd);
	public abstract function onMenuEvent ($cmd, $param);	
	public function onItemData (&$itemData) {
		// Can change properties like icon_id here ...
	}
	
	
	public function createCommandBar () {
		return "";
	}

		
	public function getRootName () {
		return $this->name;
	}


	private function renderList ($parentId, $fTreeViewLine=true, $fTreeViewOpen=true, $fIgnore=false) {

		$html = "";
		$itemList = $this->tree->getItems ($parentId);
		if (!$itemList)
			return $html;
			
		$treeId = $this->id."-".$parentId;

		$fLine = $fTreeViewLine;
		
		$view = WSystem::getParam ("view");
		
		foreach ($itemList as $itemId => $itemData) {
			if (($itemId == $this->tree->getIgnoreItemId ()))				
			{
				$fIgnore2 = true;
			}
			else {
				$fIgnore2 = $fIgnore;
			}
			
			$this->onItemData ($itemData);
			
			$fOpen = $fTreeViewOpen;
			if ($itemData["parent_id"]==$parentId) {
				$fBottom = false;
				if ($this->tree->hasChildren ($itemId) || (isset ($itemData["show_open"]) && $itemData["show_open"])) {
					$html.='<li>';
					

					if (!isset ($itemData["is_open"]) || !$itemData["is_open"])
						$fOpen=false;
					if ($fOpen && $this->tree->hasChildren ($itemId))
						$iconFilename = "minus.gif";
					else
						$iconFilename = "plus.gif";
					if ($this->tree->isBottomItem ($itemId)) {
						if ($fOpen && $this->tree->hasChildren ($itemId))
							$iconFilename = "minusbottom.gif";
						else
							$iconFilename = "plusbottom.gif";
						
						$fLine = false;
						if (!$this->tree->isBottomItem ($itemData["parent_id"]))
							$fTreeViewLine = true;
							
						$fBottom = true;
					}
					$onclick = "";

					$onclick= 'WUI.toggleTreeview (\''.$this->id.'-'.$itemId.'\','.($fBottom ? 1 : 0).',\''.WSystem::getRequestURI (array ("view" => ($view != "init" ? $view : ""), $this->id."item_id"=>$itemId, $this->id."line"=>($fBottom ? 0 : 1), $this->id."_is_ajax"=>1), true).'\');return false;';
					if ($fIgnore2) {
						$onclick="return false;";
					}
					$html.='<a href="javascript:void(0);" onclick="'.$onclick.'" ><img id=\'toggle-img-'.$this->id.'-'.$itemId.'\' class="minus" src="images/tree/'.$iconFilename.'" alt="" width="18" height="18" /></a>';
				}
				else {
					if ($this->tree->isBottomItem ($itemId)) {
						$fBottom = true;

						if (!$this->tree->isBottomItem ($itemData["parent_id"]))
							$fTreeViewLine = true;
						$html.='<li class="join_bottom">';
					}
					else {
						$html.='<li class="join">';
					}
				}

				$onmouseclick = "onItemClick".$this->id."(event,this,".$itemId.");";
				$onmousedown = "onContextMenu".$this->id."(event,this,".$itemId.");";

				$itemClass = "text";
				
				if (isset ($itemData["is_marked"]) && $itemData["is_marked"])
					$itemClass.=' marked';

				if (isset ($itemData["is_marked_once"]) && $itemData["is_marked_once"]) {
					$itemClass.=' marked';
					$this->tree->removeItemAttribute ($itemId, "is_marked_once");
				}
				if ($itemId==$this->tree->getSelectedItemId ()) 
					$itemClass.=' selected"';
				if ($fIgnore2) {
					$onmousedown = "";
					$onmouseclick = "";
					$itemClass.=' ignored';
				}
				if (isset ($itemData["extra_class"])) {
					$itemClass.=' '.$itemData["extra_class"];
				}
				// Get Icon
				$icon_id = 0;
				if (isset ($itemData["icon_id"]))
					$icon_id = $itemData["icon_id"];
				if (!isset ($this->iconMap[$icon_id])) {
					$iconFilename = "images/tree/page.gif";
					$width  = 18;
					$height = 18;
				}
				else {
					list ($iconFilename, $width, $height) = $this->iconMap[$icon_id];
				}
				
				
				$title = "";
				if (isset($itemData["item_title"]))
					$title = 'title="'.htmlspecialchars ($itemData["item_title"]).'"';
				
				$html.='<img src="'.$iconFilename.'" alt="" width="'.$width.'" height="'.$height.'" /><a class="'.$itemClass.'" onmousedown="'.$onmousedown.'" '.$title.' onclick="'.$onmouseclick.'" id="item-'.$this->id.'_'.$itemId.'" href="javascript:void(0);">'.htmlspecialchars($itemData["name"]).'</a>';				
				if ($fOpen)
					$html.='<div id="wrap_'.$this->id.'-'.$itemId.'">'.$this->renderList ($itemId, $fLine, $fOpen, $fIgnore2).'</div>';
				else
					$html.='<div id="wrap_'.$this->id.'-'.$itemId.'"></div>';				
				$html.="</li>";
			}
		}
		if ($html!="") {
			$extraClass = "";
			
			
			if ($parentId!=0)
			{
				$extraClass = "treeview_sub";
				if ($fTreeViewLine)
					$extraClass.=" treeview_line";
			}
			else {
				$extraClass = "treeview_first";

			}
			if (!$fTreeViewOpen)
				$extraClass.=" hidden";
			
			$html = '<ul id="'.$treeId.'" class="treeview '.$extraClass.'">'.$html.'</ul>';

			if (!$parentId) {
				$html = $this->createCommandBar ().$html;
			}
			if ((int) WSystem::getParam ($this->id."_is_ajax") && $this->getCommand ()=="open" && $this->getItemId()==$parentId) {

					$this->html = $html;
					$this->saveTree ();
					WUI::updateArea ("wrap_".$treeId, $html);

			}

		
			return $html;
		}
		return "";
	}
	
	public function setIconMap ($iconMap) {
		$this->iconMap = $iconMap;
	}
	
	private function setFirstItem () {
		$onclick = "onItemClick".$this->id."(event,this,0);";
		$onmousedown = "onContextMenu".$this->id."(event,this,0);";
		$itemClass = "text";
		if ($this->getItemId ()==0 && $this->tree->getSelectedItemId ()==0) 
			$itemClass.=" selected";
		// onmousedown="'.$onmousedown.'" 
		$this->html = $html = $this->createCommandBar ().'<div class="treeview_first_item"><img src="images/tree/base.gif" width="19" height="18"  alt="" /><a class="'.$itemClass.'" id="item-'.$this->id.'_0" onmousedown="'.$onmousedown.'" onclick="'.$onclick.'" href="javascript:void(0);"><!-->'.htmlspecialchars ($this->name).'<!--></a></div>'.$this->html;

	}
	
	public function renderElement ()
	{
		$view = WSystem::getParam ("view");
		
		if ($this->getCommand ()=="select") {
			$this->tree->selectItem ($this->getItemId ());			
		}
		
		$ret = $this->onTreeEvent ($this->getCommand ());
		
		$fUpdateAll = $this->onMenuEvent (
			$this->getContextMenuCommand (), 
			$this->getContextMenuParam ());

	
		$parentId = $this->getItemId ();
		if ($this->getCommand ()=="close" || 
		    $this->getCommand ()=="select") {
			$this->showAndClosePopup ();
		}
		
		$fTreeViewLine = true;
		if (WSystem::isParam ($this->id."line")) {
			$fTreeViewLine = WSystem::getParam ($this->id."line");
		}
		$this->html=$this->renderList ($parentId, $fTreeViewLine);
		if ($parentId==0) {
			$this->setFirstItem ();
		}
		if (!$this->fRenderOnlyContent && $parentId==0 && !$this->isContextMenuCommand ()) {
			$onmousedown = "";
			if ($this->contextMenu) {
				$onmousedown = $this->contextMenu->getShowFunctionName ()."(event,this,0);";
			}

			$this->html = '<div class="treeview_frame" oncontextmenu="return false;" onmousedown="'.$onmousedown.';"><div id="wrap_'.$this->id.'"  class="treeview_frame_in">'.$this->html.'</div></div>';
			
			// onMouseDown function
			$this->html.='
			<script type="text/javascript">
				
				function onContextMenu'.$this->id.' (evt,obj,itemId) {

					if (evt.button==2 && itemId!=0) {';
			if ($this->itemContextMenu) {
				$this->html.=$this->itemContextMenu->getShowFunctionName ()."(evt,obj,itemId);";
			}
			$this->html.='
					}
				}
				
				function onItemClick'.$this->id.' (evt,obj,itemId) {

					if (evt.button!=2) {
						WUI.ajaxRequest (\''.WSystem::getRequestURI (array ("view"=>($view!="init" ? $view : ""))).'\', \'empty\', null, false, \''.$this->id.'_cmd=select&'.$this->id.'item_id=\'+itemId);
					
					}	
					
				}
				
				</script>
			';
			
		}
		$this->saveTree ();
		if ($fUpdateAll)
			WUI::updateArea ("wrap_".$this->id, $this->html);

	}
	
	public function show ($fAsync=false) {
		$this->html = $this->renderList (0);
		$this->setFirstItem ();
		$this->saveTree ();	
		if (!$fAsync)
			WUI::updateArea ("wrap_".$this->id, $this->html);	
		else
			WUI::updateAreaAsync ("wrap_".$this->id, $this->html);	
	}

	public function showAndClosePopup ($popupId="") {
		$this->html = $this->renderList (0);
		$this->setFirstItem ();
		$this->saveTree ();
		WUI::updateArea ("wrap_".$this->id, $this->html, array ("closePopupId" => $popupId));
	}
	
	public function setContextMenu ($contextMenu) {
		$this->contextMenu = $contextMenu;
	}
	
	public function setItemContextMenu ($contextMenu) {
		$this->itemContextMenu = $contextMenu;
	}
	
	private function isContextMenuCommand () {
		return ! (($this->contextMenu==NULL || $this->contextMenu->getCommand ()=="") && ($this->itemContextMenu==NULL || $this->itemContextMenu->getCommand ()==""));
	}
	
	public function getContextMenuCommand () {
		if ($this->contextMenu && $this->contextMenu->getCommand ()!="")
			return $this->contextMenu->getCommand ();
		if ($this->itemContextMenu && $this->itemContextMenu->getCommand ()!="")
			return $this->itemContextMenu->getCommand ();
		return NULL;
	}	
	
	public function getContextMenuParam () {
		if ($this->contextMenu && $this->contextMenu->getParam ()!="")
			return $this->contextMenu->getParam ();
		if ($this->itemContextMenu && $this->itemContextMenu->getParam ()!="")
			return $this->itemContextMenu->getParam ();
		return "";
	}

	public function getItemContextButton ($name, $cmd) {

		return WUI::createButton ($name, $cmd, WUI::BUTTON_DEFAULT, array ("extra-class"=>"default_button", "onclick"=>'WUI.ajaxRequest (\''.WSystem::getRequestURI (array(),true).'\', \'empty\',null, false, \''.$this->itemContextMenu->getElementId().'_cmd='.$cmd.'&'.$this->itemContextMenu->getElementId().'_param='.$this->tree->getSelectedItemId().'\')'),true);
	
	}
			
	public function getCommand () {
		return WSystem::getParam ($this->id."_cmd");
	}

	public function getItemId () {
		return (int) WSystem::getParam ($this->id."item_id");
	}
	
	public function getTree () {
		return $this->tree;
	}
}


?>