<?php

/**

 WUITabulator

**/

class WUITabulator extends WUIElement
{

	private $pageList = array ();
	private $pageIdx = 0;
	private $selectedPageIdx = 0;
	private $extraStyle = "";
	private $extraStyle2 = "";
	private $rightInfo = "";
	private $fSaveTab = false;
	private $fAutoHeight = true;


	public function __construct ($id, $extraStyle="width:100%;", $fSaveTab=false, $fAutoHeight=true, $extraStyle2="") {
		$this->extraStyle = $extraStyle;
		$this->extraStyle2 = $extraStyle2;
		$this->fSaveTab = $fSaveTab;
		$this->fAutoHeight = $fAutoHeight;
		parent::__construct ($id);
	}


	public function renderElement () {
		$htmlContent = $htmlNav = "";
		$cookieTabIdx = -1;
		$cookieActivateScript = "";
		if (isset ($_COOKIE['wsystem_'.$this->id.'_tab']))
			$cookieTabIdx = $_COOKIE['wsystem_'.$this->id.'_tab'];
		
		
		foreach ($this->pageList as $idx => $data) {
			list ($topic, $html, $activateScript) = $data;
			
			$contentId = $this->id.'_content_'.$idx;

			
			$extra = "";
			$extra2 = 'display:none;';

			if ($idx==$this->selectedPageIdx) {
				
				$extra=' class="marked"';
				$extra2 = "";
			}
			if (!$this->fAutoHeight)
				$extra2.='overflow:auto;';
			
			$htmlContent.='<div style="'.$extra2.'" id="'.$contentId.'" class="tabulator_content">'.$html.'</div>';
			
			$jsFunc = $this->id.'_selectTabSlide('.$idx.',\''.addslashes ($activateScript).'\');';
			
			$htmlNav.='<span><a '.$extra.' onclick="'.$jsFunc.'return false;" href="#"><!-->'.htmlspecialchars ($topic).'<!--></a></span>';
			if ($idx==$cookieTabIdx) {
				$cookieActivateScript = $activateScript;
			
			}
		}
		$extraClass = "";
		$this->html = '
			<script type="text/javascript">
			'.$this->id.'_oldTabSlideIdx = 0;
			function '.$this->id.'_selectTabSlide(idx, activateScript) {
				$(\'#'.$this->id.'_nav a:eq(\'+'.$this->id.'_oldTabSlideIdx+\')\').removeClass(\'marked\');
				$(\'#'.$this->id.'_nav a:eq(\'+idx+\')\').addClass (\'marked\');
				
				$(\'#'.$this->id.'_content_\'+'.$this->id.'_oldTabSlideIdx).hide();
				$(\'#'.$this->id.'_content_\'+idx).show();

				if (activateScript) {

					eval (activateScript);
				}
			
				'.$this->id.'_oldTabSlideIdx=idx;
				';
			if ($this->fSaveTab) {	
				$this->html.='
					jQuery.cookie(\'wsystem_'.$this->id.'_tab\', idx, {path:\'/\'});';
			}
			
			if ($this->fAutoHeight) {
				$this->html.='
					WUI.onWindowResize ();
					
				';
			}
			else {
				$extraClass.=" no_auto_height";			
			}

			$this->html.='
				
			}
			</script>
			<div class="tabulator_frame" style="'.$this->extraStyle.'">
				
				<div id="'.$this->id.'_nav" class="tabulator_navigation"><span class="right_info">'.$this->rightInfo.'</span>'.$htmlNav.'</div>
				<div  class="tabulator_content_frame" style="'.$this->extraStyle2.'">
					<div  class="tabulator_content_frame_in'.$extraClass.'">
						'.$htmlContent.'
					</div>
				</div>
			</div>
			<script type="text/javascript">


			';
			
		if ($this->fAutoHeight) {

			$this->html.='WUI.setResize (\'.tabulator_content_frame_in:not(.no_auto_height)\', { target : \'window\', minHeight : 500, offsetY : -270, prio : -1 });';
		}

		
		if ($this->fSaveTab) {
			$this->html.= '
			if (jQuery.cookie(\'wsystem_'.$this->id.'_tab\')) {	  
				var tabIdx = parseInt (jQuery.cookie(\'wsystem_'.$this->id.'_tab\'));
				'.$this->id.'_selectTabSlide(tabIdx, \''.addslashes ($cookieActivateScript).'\');
				
			}';
		}
		else {
			$this->html.=$this->id.'_selectTabSlide(0, \'\');';		
		}
		
		$this->html.='		
			</script>
		';

	}
	
	public function setRightInfo ($html) {
		$this->rightInfo = $html;
	}
	
	public function setAutoHeight ($on) {
		$this->fAutoHeight = $on;
	}
		
	public function setSaveTab ($on) {
		$this->fSaveTab = $on;
	}

	public function addPage ($topic, $html, $activateScript="") {

		$this->pageList[$this->pageIdx]= array ($topic, $html, $activateScript);
		$this->pageIdx++;
		return $this->pageIdx;
	}
	
	public function setPage ($idx, $topic, $html, $activateScript="") {
		$this->pageList[$idx]= array ($topic, $html, $activateScript);
	}	
	
	public function selectPage ($idx) {
		$this->selectedPageIdx = $idx;
	}
	
};

?>