<?php

/**

 WUtils

**/

class WUtils
{

	public static function genPassword($length=9, $strength=0, $timeOffs=0) {
		// srand (time ()+$timeOffs);
		$vowels = 'aeuy';
		$consonants = 'bdghjmnpqrstvz';
		if ($strength & 1) {
			$consonants .= 'BDGHJLMNPQRSTVWXZ';
		}
		if ($strength & 2) {
			$vowels .= "AEUY";
		}
		if ($strength & 4) {
			$consonants .= '23456789';
		}
		if ($strength & 8) {
			$consonants .= '@#$%';
		}
	 
		$password = '';
		$alt = time() % 2;
		for ($i = 0; $i < $length; $i++) {
			if ($alt == 1) {
				$password .= $consonants[(rand() % strlen($consonants))];
				$alt = 0;
			} else {
				$password .= $vowels[(rand() % strlen($vowels))];
				$alt = 1;
			}
		}
		return $password;
	}
	
	

	public static function createCompatibleFilename ($name, $separator="_", $maxChars=0)
	{
		$filename = "";
		$ignoreSpace = false;
		// Replace special chars
		$name = str_replace (
			array (".", "|", "ä","Ä","ö","Ö","ü","Ü","ß","é"),
			array ("", " ", "ae","ae","oe","oe","ue","ue","ss","ee"),
			$name);
		
		$name = utf8_decode ($name);	
		$length = strlen($name);
		$ignoreSpace=false;	
		for ($i=0;$i<$length;$i++) {
			$c = $name[$i];
	
			if ($ignoreSpace && $c==' ')
				continue;
				
			if ($c==' ') {
				$c=$separator; $ignoreSpace=true;
			}
			else {
				$c = strtolower ($c);
				if (($c<"a" || $c>"z") && ($c<"0" || $c>"9") && $c!=$separator)
					continue;
				else
					$ignoreSpace=false;	
			}
			$filename.=$c;
		}
		if ($maxChars>0 && strlen ($filename)>$maxChars)
			$filename=substr ($filename, 0, $maxChars);
		
		return trim ($filename, $separator);
	}	
	
	public static function encodeQuotedPrintable ($input, $line_max = 76) {
		$hex    = array('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'); 
		$lines  = preg_split("/(?:\r\n|\r|\n)/", $input); 
		$eol    = "\n"; 
		$escape = "="; 
		$output = ""; 
		  
		while( list(, $line) = each($lines) ) { 
			//$line  = rtrim($line); // remove trailing white space -> no =20\r\n necessary 
			$linlen  = strlen($line); 
			$newline = ""; 
			for ($i = 0; $i < $linlen; $i++) { 
				$c   = substr($line, $i, 1); 
				$dec = ord($c); 
				if ( ($dec == 32) && ($i == ($linlen - 1)) ) {  // convert space at eol only 
					$c = "=20"; 
				}
				elseif (($dec == 61) || ($dec < 32 ) || ($dec > 126)) {  // always encode "\t", which is *not* required 
					$h2 = floor($dec/16); $h1 = floor($dec%16); 
					$c = $escape.$hex["$h2"].$hex["$h1"]; 
				} 
				if ((strlen($newline) + strlen($c)) >= $line_max) { // CRLF is not counted 
					$output .= $newline.$escape.$eol; // soft line break; " =\r\n" is okay 
					$newline = ""; 
				} 
				$newline .= $c; 
			} // end of for 
			$output .= $newline.$eol; 
		} 
	  
		return trim($output); 
	} 
	
	public static function sendMail ($from, $to, $subject, &$content_text, &$content_html, $reply_to="", $filenames=array ()) {
	
		$boundary_id0  = time()."_".rand ();
		$boundary_id1   = time()."_".rand ();
		$boundary_id2  = time()."_".rand ();
	
		$keys = array (
			"[boundary_id0]", 
			"[boundary_id1]",
			"[boundary_id2]",
			"[content_length_text]",
			"[content_length_html]",
			"[content_length_file]",
			"[content_text]",			
			"[content_html]",
			"[content_attachments0]",
			"[content_attachments1]");
		/*
		quoted-printable
		$content_text_enc    = WUtils::encodeQuotedPrintable ($content_text);
		$content_html_enc    = WUtils::encodeQuotedPrintable ($content_html);
		*/
		
		$content_text_enc    = chunk_split(base64_encode($content_text),76,"\n");
		$content_html_enc    = chunk_split(base64_encode($content_html),76,"\n");

		
		
		$content_file_enc    = "";
		$content_length_text = strlen ($content_text_enc);
		$content_length_html = strlen ($content_html_enc);
		$content_length_file = 0;
		$content_attachments = "";
	
		// windows-1252	
	
		$body = "------=_NextPart_[boundary_id0]\n".
				"Content-Type: text/plain; charset=utf-8\n".
				"Content-Transfer-Encoding: base64\n".
				"Content-Length: [content_length_text]\n".
				"\n".
				"[content_text]\n".
				"------=_NextPart_[boundary_id0]\n".
				"Content-Type: text/html; charset=utf-8\n".
				"Content-Transfer-Encoding: base64\n".
				"Content-Length: [content_length_html]\n".
				"\n".
				"[content_html]\n".
				"\n".
				"------=_NextPart_[boundary_id0]--";
	
		$body2 = "This is a multi-part message in MIME format.\n".
				"\n".
				"------=_NextPart_[boundary_id0]\n".
				"Content-Type: multipart/related;type=\"multipart/alternative\";boundary=\"----=_NextPart_[boundary_id1]\"\n".
				"\n".
				"\n".
				"------=_NextPart_[boundary_id1]\n".
				"Content-Type: multipart/alternative;boundary=\"----=_NextPart_[boundary_id2]\"\n".
				"\n".
				"\n".
				"------=_NextPart_[boundary_id2]\n".
				"Content-Type: text/plain; charset=utf-8\n".
				"Content-Transfer-Encoding: base64\n".
				"Content-Length: [content_length_text]\n".
				"\n".
				"[content_text]\n".
				"------=_NextPart_[boundary_id2]\n".
				"Content-Type: text/html; charset=utf-8\n".
				"Content-Transfer-Encoding: base64\n".
				"Content-Length: [content_length_html]\n".
				"\n".
				"[content_html]\n".
				"\n".
				"------=_NextPart_[boundary_id2]--\n".
				"\n".
				"[content_attachments1]".
				"------=_NextPart_[boundary_id1]--\n".
				"\n".
				"[content_attachments0]".
				"------=_NextPart_[boundary_id0]--";
		$fAttachments=false;
		foreach ($filenames as $fileData) {
			$fAttachment0 = true;
			if (!is_array ($fileData))
				$filename = $fileData;
			else
			if (isset ($fileData["filename"]))
				$filename = $fileData["filename"];
			else
				continue;
				
			if ($filename!="" && file_exists ($filename)) {
				if ($handle = fopen($filename, "rb")) {
					$content_file = fread ($handle, filesize ($filename));
					$content_file_enc = chunk_split(base64_encode($content_file),76,"\n");
					$content_length_file = filesize ($filename);
					fclose ($handle);
					$contentType = "application/octet-stream";					
					$extra = "Content-Disposition: attachment; filename=".basename($filename)."\n";
					if (is_array ($fileData)) {
						if (isset ($fileData["Content-Type"])) {
							$contentType = $fileData["Content-Type"];
							$fAttachment0 = false;
						}
						if (isset ($fileData["Content-ID"])) {
							$extra = 
								"Content-ID: <".$fileData["Content-ID"].">\n".
								"Content-Description: ".basename($filename)."\n".
								"Content-Location: ".basename($filename)."\n";
								$fAttachment0 = false;
						}
					}
					if ($fAttachment0)
						$boundary = $boundary_id0;
					else
						$boundary = $boundary_id1;

					$content_attachment=
						"------=_NextPart_".$boundary."\n".
						"Content-Type: ".$contentType."; name=".basename($filename)."\n".
						"Content-Transfer-Encoding: base64\n".
						$extra.
						"Content-Length: ".$content_length_file."\n".
						"\n".
						$content_file_enc."\n".
						"\n";						
					if ($fAttachment0)
						$content_attachments0.=$content_attachment;
					else
						$content_attachments1.=$content_attachment;
					$fAttachments=true;
				}
			}	
		}	

					
		
		$values = array (
			$boundary_id0, 
			$boundary_id1,
			$boundary_id2,
			$content_length_text,
			$content_length_html,
			$content_length_file,		
			$content_text_enc,			
			$content_html_enc,
			$content_attachments0,
			$content_attachments1);
			
		if ($fAttachments)
			$body = str_replace($keys, $values, $body2);
		else
			$body = str_replace($keys, $values, $body);
	
		// Send mail
		$extra = "";
		if ($reply_to!="")
			$extra="Bcc: ".$reply_to."\n";
	
		if ($fAttachments)
			$content_type = "multipart/mixed"; 
		else
			$content_type = "multipart/alternative";
		return mail(
				$to, 
				'=?UTF-8?B?'.base64_encode($subject).'?=', 
				$body,
				$extra."From: ".$from."\nMIME-Version: 1.0\n".
				"Content-Type: ".$content_type.";boundary=\"----=_NextPart_".$boundary_id0."\"");
	}
	
	public static function getFileExtension ($filename) {
		$tmp = pathinfo ($filename);
		return $tmp["extension"];
	}
	
	public static function moveUploadFile ($uploadFilename, $oldFilename, $path, $baseName) {
		/*
		$uploadFilename = utf8_decode ($uploadFilename);
		$oldFilename = utf8_decode ($oldFilename);
		$baseName = utf8_decode ($baseName);
		*/
		// Move file
		if (empty ($uploadFilename))
			return $oldFilename;
		if (!empty ($oldFilename)) {
			// Unlink old file
			$filename = ROOT_PATH."/".$path."/".$oldFilename;
			$pathinfo = pathinfo ($filename);
			if (is_file ($filename))
				unlink ($filename);
			$filename = $pathinfo["dirname"]."/".$pathinfo["filename"]."_original.".$pathinfo["extension"];
			if (is_file ($filename))
				unlink ($filename);
		}
		$filename = UPLOAD_PATH."/".$uploadFilename;
		$pathinfo = pathinfo ($filename);
		$filename_ = UPLOAD_PATH."/".$pathinfo["filename"]."_original.".$pathinfo["extension"];
		$filename2 = ROOT_PATH."/".$path."/".($newFilename=$baseName.".".strtolower ($pathinfo["extension"]));
		$filename2_ = ROOT_PATH."/".$path."/".($baseName."_original.".strtolower ($pathinfo["extension"]));
		if (is_file ($filename)) {
			if (is_file ($filename2)) {
				unlink ($filename2);
			}
			rename ($filename, $filename2);
		}
		if (is_file ($filename_)) {
			if (is_file ($filename2_)) {
				unlink ($filename2_);
			}
			rename ($filename_, $filename2_);
		}
		// Rename cache file
		$cacheFilename = CACHE_PATH."/tb_".md5($filename).".jpg";
		$cacheFilename2 = CACHE_PATH."/tb_".md5($filename2).".jpg";
		if (is_file ($cacheFilename2))
			unlink ($cacheFilename2);
		if (is_file ($cacheFilename))
			rename ($cacheFilename, $cacheFilename2);
		return $newFilename;
	}
	
	public static function removeFile ($filename) {
		$filename = utf8_decode ($filename);
		if (!is_file ($filename))
			return false;
		$pathinfo = pathinfo ($filename);
		unlink ($filename);
		$filename_ = $pathinfo["dirname"]."/".basename($pathinfo["filename"])."_original.".$pathinfo["extension"];
		if (is_file ($filename_))
			unlink ($filename_);
		$newCacheFilename = CACHE_PATH."/tb_".md5($filename).".jpg";
		if (is_file ($newCacheFilename))
			unlink ($newCacheFilename);
		return true;
	}
	
	public static function renameFile ($filename, $filename2) {
		$filename = utf8_decode ($filename);
		$filename2 = utf8_decode ($filename2);
		if (!is_file ($filename))
			return false;
			
		$cacheFilename = CACHE_PATH."/tb_".md5($filename).".jpg";
		if (is_file ($cacheFilename))
			unlink ($cacheFilename);
		rename ($filename,$filename2);
		$pathinfo = pathinfo ($filename);		
		$filename_ = $pathinfo["dirname"]."/".basename($pathinfo["filename"])."_original.".$pathinfo["extension"];
		$pathinfo2 = pathinfo ($filename2);		
		$filename2_ = $pathinfo2["dirname"]."/".basename($pathinfo2["filename"])."_original.".$pathinfo2["extension"];
		if (is_file ($filename_))
			rename ($filename_,$filename2_);
		return true;
	}
	
	
	public static function removeCacheFile ($filename) {
		$cacheFilename = CACHE_PATH."/tb_".md5(utf8_decode ($filename)).".jpg";
		if (is_file ($cacheFilename))
			unlink ($cacheFilename);
	}
	
	
	public static function emptyCache ($user_id) {
		// Empty upload path
		if ($dh = opendir(UPLOAD_PATH)) {
			while (false !== ($filename = readdir($dh))) {
				$p = strpos ($filename, $user_id."_");
				if ($filename=="." || $filename==".." || $p===false || $p!=0)
					continue;
				$uploadFilename = UPLOAD_PATH."/".$filename;	
				$cacheFilename = CACHE_PATH."/tb_".md5($uploadFilename).".jpg";	
				if (is_file ($cacheFilename))
					unlink ($cacheFilename);
				unlink ($uploadFilename);		
			}
		}
		// Empty tmp path
		if ($dh = opendir(ROOT_PATH."/tmp")) {
			while (false !== ($filename = readdir($dh))) {
				$p = strpos ($filename, $user_id."_");
				if ($filename=="." || $filename==".." || $p===false || $p!=0)
					continue;
				$tmpFilename = ROOT_PATH."/tmp/".$filename;	
				if (is_file ($tmpFilename))
					unlink ($tmpFilename);
			}
		}
	}
		
	public static function templateText ($tlp, $values, $fHTMLSpecial=false, $fReplaceQuotes=true) {	
		$keys = array ();
		foreach ($values as $key => $value) {
			$pos = strpos ($key, '#');
			$flag = false;
			if ($pos!==false && $pos==0) {
				$flag = true;
				$key = substr ($key, 1);
			}
			if ($fHTMLSpecial && !$flag)
				$values[$key]=htmlspecialchars ($value);
			else
			{
				if ($fReplaceQuotes)
					$values[$key]=str_replace (array ("\""), array ("'"), $value);
				else
					$values[$key]=$value;
			}
			array_push ($keys, '{'.$key.'}');
		}
		return str_replace($keys, array_values ($values), $tlp);
	}	
	
	public static function isExternURL ($url) {		
		$list = parse_url ($url);
		if (isset ($list["host"]) && !empty ($list["host"])) {
			return true;
		}			
		return false;
	}
		
};

?>