<?php

/**

 WLanguage
 German

**/

class WLanguage 
{
	/* Formatting */	
	const INVALID_DATE         = "Ungültiges Datum. TT.MM.JJJJ erforderlich.";
	const INVALID_FLOAT        = "Ungültiges Zahlenformat.";
	const INVALID_EMAIL        = "Ungültiges EMail-Format.";
	const INVALID_FILENAME     = "Dateiname enthält ungültige Zeichen.";
	const INVALID_URL          = "Ungültige URL. Format http://... erforderlich.";
	const FLOAT_TO_LONG        = "Zu viele Vorkommastellen (max. %d).";
	const INT_TO_LONG          = "Zu viele Stellen (max. %d).";
	const STRING_TO_LONG       = "Zu viele Zeichen (max. %d).";
	
	/* Forms */
	const CREATE               = "Anlegen";
	const CREATED						 	 = "Angelegt";
	const SAVE                 = "Speichern";
	const CHANGED						 	 = "Geändert";
	const DELETE               = "Löschen";
	const SEARCH							 = "Suchen";
	const CLOSE								 = "Schließen";
	const EDIT								 = "Bearbeiten";	
	const MOVE_TO							 = "Verschieben";
	const MOVE_UP							 = "Nach oben";
	const MOVE_DOWN						 = "Nach unten";
	const SORT								 = "Sortieren";
	const FIELD_REQUIRED       = "Dieses Feld ist ein Pflichtfeld.";	
	const CHECK_MARKED_FIELDS  = "Bitte überprüfen Sie die markierten Felder.";
	const ENTRY_WAS_DELETED    = "Eintrag wurde gelöscht.";
	const DELETE_QUESTION      = "Wollen Sie den Eintrag löschen?";
	const SESSION_INCOMPATIBLE = "Die Ansicht wurde in einem anderen Browserfenster verändert. Bitte arbeiten Sie nicht mit mehreren Browserfenstern.";
	const BACK_TO_OVERVIEW   	 = "Zurück zur Übersicht";
	const BACK_TO_LIST  		 	 = "Zurück zur Liste";
	const CLICK				  		 	 = "KLICK";
	const NEXT				  		 	 = "Weiter";
	const BACK    				  	 = "Zurück";
	const FIRST_ENTRY	  		 	 = "Erster Eintrag";
	const LAST_ENTRY				   = "Letzter Eintrag";
					
	/* Misc */
	const CURRENCY_SYMBOL      = "&#8364;";
	const CURRENCY_NAME        = "Eur";
	
	/* Date format */
	const DATE_FORMAT					= "dd.MM.yyyy";
	
	public static function setLocale () {
		setlocale (LC_ALL, 'de_DE@euro', 'de_DE', 'de', 'ge');
		date_default_timezone_set ("Europe/Berlin");
	}
	
	public static function formatDate ($year, $month, $day) {
		return sprintf ("%02d.%02d.%04d", $day, $month, $year);
	} 	
	
	public static function formatDateTime ($year, $month, $day, $hour, $minute, $second) {
		$format = "%02d.%02d.%04d %02d:%02d:%02d";
		if ($second==-1)
			$format = "%02d.%02d.%04d %02d:%02d";
		return sprintf ($format, $day, $month, $year, $hour, $minute, $second);
	}	

	public static function checkDate ($value) {
		if ($value!="") {
			$parts = explode(".", $value); 
			if ((count ($parts)!=3) || !checkdate (intval ($parts[1]), intval ($parts[0]), intval ($parts[2]))) {		
				return false;
			}
		}
		return true;
	}

	public static function parseDate ($value) {
		if ($value=="")
			return "0000-00-00";
			
		$parts = explode(".", $value); 						
		return sprintf ("%04d-%02d-%02d", intval ($parts[2]), intval ($parts[1]), intval ($parts[0]));
	}
	
	public static function parseDateTime ($value, $fSeconds=true) {
		list($day, $month, $year, $hour,$minute,$second) =  sscanf($value, "%02d.%02d.%04d %02d:%02d:%02d");
		return sprintf ("%04d-%02d-%02d %02d:%02d".($fSeconds ? ":%02d" : ""), $year, $month, $day, $hour, $minute, $second);
	}
	
	public static function getSalutations ($fAll=false) {
		if ($fAll)	
			return array (1 => "Herr", 2 => "Frau", 3=> "Familie", 4 => "Firma");
		return array (1 => "Herr", 2 => "Frau");
	}
	
	public static function getSalutationText ($salutation_id, $name) {
		switch ($salutation_id) {
			case 1: return "Sehr geehrter Herr ".$name;break;
			case 2:;
			case 3: return "Sehr geehrte Frau ".$name;break;
		}
		return "Sehr geehrte Damen und Herren";
	}
	
	public static function getTitles () {
		return array (1 => "Dr.", 2=>"Dr. Dr.", 3 => "Prof.", 4=>"Prof. Dr.");
	}
	
	public static function getYesNos ($offs=0) {
		return array ((0+$offs) => "NEIN", (1+$offs) => "JA");
	}
	
	public static function  getWeekDays ($fShort=false) {
		if ($fShort)
			return array (0=>"Mo", 1=>"Di", 2=>"Mi", 3=>"Do", 4=>"Fr", 5=>"Sa", 6=>"So");
		return array (0=>"Montag", 1=>"Dienstag", 2=>"Mittwoch", 3=>"Donnerstag", 4=>"Freitag", 5=>"Samstag", 6=>"Sonntag");
	}
	
	public static function  getMonths ($fShort=false) {
		if ($fShort)
			return array (1=>"Jan", 2=>"Feb", 3=>"Mrz", 4=>"Apr", 5=>"Mai", 6=>"Juni", 7=>"Juli", 8=>"Aug",9=>"Sep",10=>"Okt",11=>"Nov",12=>"Dez");
		return array (1=>"Januar", 2=>"Februar", 3=>"März", 4=>"April", 5=>"Mai", 6=>"Juni", 7=>"Juli", 8=>"August",9=>"September",10=>"Oktober",11=>"November",12=>"Dezember");
	}
	
};

?>