<?php

/**

 WLanguage
 English

**/

class WLanguage 
{
	/* Formatting */	
	const INVALID_DATE         = "Invalid Date. dd/MM/yyyy required.";
	const INVALID_FLOAT        = "Invalid number formats.";
	const INVALID_EMAIL        = "Invalid EMail format.";
	const INVALID_FILENAME     = "Filename has invalid characters.";
	const INVALID_URL          = "Invalid URL format. http://... reqired.";
	const FLOAT_TO_LONG        = "Too many decimal places (max. %d).";
	const INT_TO_LONG          = "Too many places (max. %d).";
	const STRING_TO_LONG       = "Too many characters (max. %d).";
	
	/* Forms */
	const CREATE               = "Create";
	const CREATED              = "Created";
	const SAVE                 = "Save";
	const CHANGED              = "Changed";
	const DELETE               = "Delete";
	const SEARCH							 = "Search";
	const CLOSE								 = "Close";
	const EDIT								 = "Edit";
	const MOVE_TO							 = "Move to";
	const MOVE_UP							 = "Move up";
	const MOVE_DOWN						 = "Move down";
	const SORT								 = "Sort";
	const FIELD_REQUIRED       = "This field is mandatory.";
	const CHECK_MARKED_FIELDS  = "Please check marked fields.";
	const ENTRY_WAS_DELETED    = "Entry was deleted.";
	const DELETE_QUESTION      = "Do you want to delete the entry?";
	const SESSION_INCOMPATIBLE = "The view was changed in another Browser windows. Do not work with multiple Browser windows.";
	const BACK_TO_OVERVIEW   	 = "Back to overview";
	const BACK_TO_LIST  		 	 = "Back to list";
	const CLICK				  		 	 = "CLICK";
	const NEXT				  		 	 = "Next";
	const BACK    				  	 = "Back";
	const FIRST_ENTRY	  		 	 = "First entry";
	const LAST_ENTRY				   = "Last entry";
				
	/* Misc */
	const CURRENCY_SYMBOL      = "&#8364;";
	const CURRENCY_NAME        = "Eur";
	
	/* Date format */
	const DATE_FORMAT					= "dd/MM/yyyy";
	
	
	
	public static function setLocale () {
		setlocale (LC_ALL, 'de_DE@euro', 'de_DE', 'de', 'ge');
		date_default_timezone_set ("Europe/Berlin");
	}
	
	public static function formatDate ($year, $month, $day) {
		return sprintf ("%02d/%02d/%04d", $day, $month, $year);
	} 
	
	public static function formatDateTime ($year, $month, $day, $hour, $minute, $second) {
		$format = "%d-%d-%d %02d:%02d:%02d";
		if ($second==-1)
			$format = "%d-%d-%d %02d:%02d";
		return sprintf ($format, $month, $day, $year, $hour, $minute, $second);
	}	

	public static function checkDate ($value) {
		if ($value!="") {
			$parts = explode("-", $value); 
			if ((count ($parts)!=3) || !checkdate (intval ($parts[0]), intval ($parts[1]), intval ($parts[2]))) {		
				return false;
			}
		}
		return true;
	}

	public static function parseDate ($value) {
		if ($value=="")
			return "0000-00-00";
			
		$parts = explode("/", $value); 						
		return sprintf ("%04d-%02d-%02d", intval ($parts[2]), intval ($parts[0]), intval ($parts[1]));
	}

	public static function parseDateTime ($value, $fSeconds=true) {
		list($month, $day, $year, $hour,$minute,$second) =  sscanf($value, "%02d-%02d-%04d %02d:%02d:%02d");
		return sprintf ("%04d-%02d-%02d %02d:%02d:".($fSeconds ? ":%02d" : ""), $year, $month, $day, $hour, $minute, $second);
	}
	
	public static function getSalutations ($fAll=false) {
		if ($fAll)	
			return array (1 => "Mr.", 2 => "Mrs./Ms.", 3=>"Family", 4 => "Company");
		return array (1 => "Mr.",  2 => "Mrs./Ms.");
	}
	
	public static function getSalutationText ($salutation_id, $name) {
		switch ($salutation_id) {
			case 1: return "Dear Mr. ".$name;break;
			case 2: return "Dear Mrs./Ms. ".$name;break;
		}
		return "Hello";
	}
	
	public static function getTitles () {
		return array (1 => "Dr.", 2=>"Dr. Dr.", 3 => "Prof.", 4=>"Prof. Dr.");
	}
	
	public static function getYesNos ($offs=0) {
		return array ((0+$offs) => "NO", (1+$offs) => "YES");
	}
	
	public static function getWeekDays ($fShort=false) {
		if ($fShort)
			return array (0=>"Mon", 1=>"Tue", 2=>"Wed", 3=>"Thu", 4=>"Fri", 5=>"Sat", 6=>"Sun");
		return array (0=>"Monday", 1=>"Tuesday", 2=>"Wednesday", 3=>"Thursday", 4=>"Friday", 5=>"Saturday", 6=>"Sunday");
	}
	
	public static function getMonths ($fShort=false) {
		if ($fShort)
			return array (1=>"Jan", 2=>"Feb", 3=>"Mar", 4=>"Apr", 5=>"May", 6=>"June", 7=>"July", 8=>"Aug",9=>"Sept",10=>"Oct",11=>"Nov",12=>"Dec");
		return array (1=>"January", 2=>"February", 3=>"March", 4=>"April", 5=>"May", 6=>"June", 7=>"July", 8=>"August",9=>"September",10=>"October",11=>"November",12=>"December");
	}	
	
};

?>