<?php



class UniversalSearchForm extends WForm
{
	private $props = NULL;
	private $universalList = NULL;
	private $fExport = false;
	private $ownCmd = "";
	private $ownCmdText = "";
	public function __construct (&$props, &$list=NULL) 
	{
		$this->props = &$props;
		$this->universalList = &$list;

		$mode = WSystem::getArrayValue ($this->props, "search_mode");
		$tokens = explode ("|", $mode);
		foreach ($tokens as $mode) {
		
			if (strpos ($mode, "=")!==false) {
				list ($mode, $value) = explode ("=", $mode);
			}
			
			switch ($mode) {
				case "export":
					$this->fExport=true;
					break;
				default:
					$this->ownCmd = $mode;
					$this->ownCmdText = $value;
					break;
			}
		}


		parent::__construct($this->props["name"]."_search_form", "search");
	}
	
	public function __destruct () {
		
	}
	
	public function getDefinition () {
		$def = array ();
		foreach ($this->props["search_fields"] as $field => $fieldProps) {
			$def[$field] = $fieldProps["input"];
		}

		return $def;
	}

	public function createMask ($cmd, $values) 
	{
		// WUI::createDropDown ("Kategorie", "category_id", $values["category_id"], getCategories (), array ("empty_option"=>1, "show_column" => "name")).				
		$this->universalList->setSearchData ($values);
		
		$htmlInput = "";
		
		foreach ($this->props["search_fields"] as $field => $fieldProps) {			

			$htmlInput.=UniversalForm::createInputField ($field, $fieldProps, $values[$field]); // WUI::createInputField ((isset ($fieldProps["name"]) ? $fieldProps["name"] : $field), $field, $values[$field], $props);
		}
		
		

		
		$btReset = WUI::createButton ("Reset", "show_all", WUI::BUTTON_DEFAULT, array ("onclick"=>"WUI.loadPage ('".WSystem::getRequestURI (array (), true)."','view=init')", true));
		$btExport = $btOwn = "";
		if ($this->fExport)
			$btExport = WUI::createButton ("Export", "export", WUI::BUTTON_DEFAULT, array ("onclick"=>"WUI.loadPage ('".WSystem::getRequestURI (array (), true)."','view=export')", true));
		if (!empty ($this->ownCmd))
		{
			$btOwn = WUI::createButton ($this->ownCmdText, $this->ownCmd, WUI::BUTTON_DEFAULT, array ("onclick"=>"WUI.loadPage ('".WSystem::getRequestURI (array (), true)."','view=".$this->ownCmd."')", true));		
		}
		return 
			 WUI::createBox (array ("id"=>$this->id."_box"),  
				WUI::createInputFrame (WUI::INPUT_FRAME_COLS, array ("id"=>$this->id."_input_frame1"),		
					$htmlInput.		
			    $this->createCommandButtons ($cmd).$btReset.$btExport.$btOwn
		    )
		 	);
	}		

	public function getNewData () {
		return NULL;
	}
	
	public function getEditData () {
		return $this->universalList->getSearchData ();
	}

	public function insert ($values) {
		return false;
	}
	
	public function update ($values) {		
		return false;
	}
	
	public function search ($values) {

		$this->universalList->reset ($values);		
		$this->universalList->show (true);
		return false;
	}

	public function delete ($values) {
		return false;
	}
}


?>